#ifndef _IO14441_INCLUDED
#define _IO14441_INCLUDED
/*
 *----------------------------------------------------------------------------------------------------------------------------------------
 *                 @@@           @@                  @@
 *                @@@@@          @@   @@             @@
 *                @@@@@          @@                  @@
 *       .@@@@@.  @@@@@      @@@ @@   @@     @@@@    @@     @@@       @@@
 *     @@@@@@   @@@@@@@    @@   @@@   @@        @@   @@   @@   @@   @@   @@
 *    @@@@@    @@@@@@@@    @@    @@   @@    @@@@@@   @@   @@   @@   @@   @@
 *   @@@@@@     @@@@@@@    @@    @@   @@   @@   @@   @@   @@   @@   @@   @@
 *   @@@@@@@@     @@@@@    @@   @@@   @@   @@   @@   @@   @@   @@   @@   @@
 *   @@@@@@@@@@@    @@@     @@@@ @@   @@    @@@@@    @@     @@@       @@@@@
 *    @@@@@@@@@@@  @@@@                                                  @@
 *     @@@@@@@@@@@@@@@@                                                  @@
 *       "@@@@@"  @@@@@    S  E  M  I  C  O  N  D  U  C  T  O  R     @@@@@
 *
 *
 * (C) Copyright Dialog Semiconductor BV, unpublished work.
 * This computer program includes Confidential, Proprietary Information and
 * is a Trade Secret of SiTel Semiconductor BV.
 * All use, disclosure, and/or reproduction is prohibited unless authorized
 * in writing. All Rights Reserved.
 *
 * File:      sc14441.h (Datasheet V0.40)
 * Purpose:   
 * Created:   Sept 15, 2009
 * By:        MG					    
 * Country:   The Netherlands
 *
 *------------------------------------------------------------------------------------------------------------------------
 * Header    : $Header: $
 * Date      : $Date: Mon Sep 29 14:09:53 2008 $
 *
 *------------------------------------------------------------------------------------------------------------------------
 * 
 *  Id       : $Id: $
 *
 *  Log      : $Log: $
 *
 *------------------------------------------------------------------------------------------------------------------------
 */

#ifdef __IAR_SYSTEMS_ICC__
	#define MODEL               1
	#define __far
#else
	#define MODEL               4
#endif


typedef unsigned short uint16;
typedef unsigned short WORD;


/*========================== USER DEFINED CONSTANTS =========================*/

#define MAX_DOG_TIME        0x00FF

/*----------------------------*/
/*  IO configurations         */
/*----------------------------*/
#define PORT_INPUT          0
#define PORT_PULL_UP        1
#define PORT_PULL_DOWN      2
#define PORT_OUTPUT         3

#ifdef __IAR_SYSTEMS_ICC__

/*======================= Start of automatic generated code =================*/

/*
 * This file is generated from Meta file "SC14441.xml"
 * With version number: 07-02-2012
 */

__no_init volatile unsigned short RAM_START @ 0x000000;

__no_init volatile unsigned short RAM_END @ 0x003FFE;

__no_init volatile unsigned short RAM_ADM_START @ 0x009000;

__no_init volatile unsigned short RAM_ADM_END @ 0x009FFE;

__no_init volatile unsigned short SHARED_RAM_START @ 0x010000;

__no_init volatile unsigned short SHARED_RAM_END @ 0x017FFE;

__no_init volatile unsigned short PROGRAM_START @ 0x020000;

__no_init volatile unsigned short PROGRAM_END @ 0xFEEFFE;

__no_init volatile unsigned short BOOT_ROM_START @ 0xFEF000;

__no_init volatile unsigned short BOOT_FROM_UART @ 0xFEF002;

__no_init volatile unsigned short BOOT_FROM_QSPI @ 0xFEF004;

__no_init volatile unsigned short BOOT_ROM_ID @ 0xFEF7F8;

__no_init volatile unsigned short BOOT_ROM_END @ 0xFEF7FE;

__no_init volatile union
{
  unsigned long QSPIC_CTRLBUS_REG;
  struct
  {
    unsigned long QSPIC_SET_SINGLE                : 1;
    unsigned long QSPIC_SET_DUAL                  : 1;
    unsigned long QSPIC_SET_QUAD                  : 1;
    unsigned long QSPIC_EN_CS                     : 1;
    unsigned long QSPIC_DIS_CS                    : 1;
  } QSPIC_CTRLBUS_REG_bit;
} @ 0xFF0C00;

__no_init volatile union
{
  unsigned long QSPIC_CTRLMODE_REG;
  struct
  {
    unsigned long QSPIC_AUTO_MD                   : 1;
    unsigned long QSPIC_CLK_MD                    : 1;
    unsigned long QSPIC_IO2_OEN                   : 1;
    unsigned long QSPIC_IO3_OEN                   : 1;
    unsigned long QSPIC_IO2_DAT                   : 1;
    unsigned long QSPIC_IO3_DAT                   : 1;
    unsigned long QSPIC_HRDY_MD                   : 1;
    unsigned long QSPIC_RXD_NEG                   : 1;
    unsigned long QSPIC_RPIPE_EN                  : 1;
    unsigned long QSPIC_PCLK_MD                   : 3;
    unsigned long QSPIC_FORCENSEQ_EN              : 1;
  } QSPIC_CTRLMODE_REG_bit;
} @ 0xFF0C04;

__no_init volatile union
{
  unsigned long QSPIC_RECVDATA_REG;
  struct
  {
    unsigned long QSPIC_RECVDATA                  : 32;
  } QSPIC_RECVDATA_REG_bit;
} @ 0xFF0C08;

__no_init volatile union
{
  unsigned long QSPIC_BURSTCMDA_REG;
  struct
  {
    unsigned long QSPIC_INST                      : 8;
    unsigned long QSPIC_INST_WB                   : 8;
    unsigned long QSPIC_EXT_BYTE                  : 8;
    unsigned long QSPIC_INST_TX_MD                : 2;
    unsigned long QSPIC_ADR_TX_MD                 : 2;
    unsigned long QSPIC_EXT_TX_MD                 : 2;
    unsigned long QSPIC_DMY_TX_MD                 : 2;
  } QSPIC_BURSTCMDA_REG_bit;
} @ 0xFF0C0C;

__no_init volatile union
{
  unsigned long QSPIC_BURSTCMDB_REG;
  struct
  {
    unsigned long QSPIC_DAT_RX_MD                 : 2;
    unsigned long QSPIC_EXT_BYTE_EN               : 1;
    unsigned long QSPIC_EXT_HF_DS                 : 1;
    unsigned long QSPIC_DMY_NUM                   : 2;
    unsigned long QSPIC_INST_MD                   : 1;
    unsigned long QSPIC_WRAP_MD                   : 1;
    unsigned long QSPIC_WRAP_LEN                  : 2;
    unsigned long QSPIC_WRAP_SIZE                 : 2;
    unsigned long QSPIC_CS_HIGH_MIN               : 3;
  } QSPIC_BURSTCMDB_REG_bit;
} @ 0xFF0C10;

__no_init volatile union
{
  unsigned long QSPIC_STATUS_REG;
  struct
  {
    unsigned long QSPIC_BUSY                      : 1;
  } QSPIC_STATUS_REG_bit;
} @ 0xFF0C14;

__no_init volatile union
{
  unsigned long QSPIC_WRITEDATA_REG;
  struct
  {
    unsigned long QSPIC_WRITEDATA                 : 32;
  } QSPIC_WRITEDATA_REG_bit;
} @ 0xFF0C18;

__no_init volatile union
{
  unsigned long QSPIC_READDATA_REG;
  struct
  {
    unsigned long QSPIC_READDATA                  : 32;
  } QSPIC_READDATA_REG_bit;
} @ 0xFF0C1C;

__no_init volatile union
{
  unsigned long QSPIC_DUMMYDATA_REG;
  struct
  {
    unsigned long QSPIC_DUMMYDATA                 : 32;
  } QSPIC_DUMMYDATA_REG_bit;
} @ 0xFF0C20;

__no_init volatile union
{
  unsigned long QSPIC_ERASECTRL_REG;
  struct
  {
    unsigned long                                 : 12;
    unsigned long QSPIC_ERS_ADDR                  : 12;
    unsigned long QSPIC_ERASE_EN                  : 1;
    unsigned long QSPIC_ERS_STATE                 : 3;
  } QSPIC_ERASECTRL_REG_bit;
} @ 0xFF0C24;

__no_init volatile unsigned long QSPIC_ERASECMDA_REG @ 0xFF0C28;

__no_init volatile union
{
  unsigned long QSPIC_ERASECMDB_REG;
  struct
  {
    unsigned long QSPIC_ERS_TX_MD                 : 2;
    unsigned long QSPIC_WEN_TX_MD                 : 2;
    unsigned long QSPIC_SUS_TX_MD                 : 2;
    unsigned long QSPIC_RES_TX_MD                 : 2;
    unsigned long QSPIC_EAD_TX_MD                 : 2;
    unsigned long QSPIC_ERS_CS_HI                 : 3;
    unsigned long                                 : 3;
    unsigned long QSPIC_ERSRES_HLD                : 4;
    unsigned long                                 : 4;
    unsigned long QSPIC_RESSUS_DLY                : 6;
  } QSPIC_ERASECMDB_REG_bit;
} @ 0xFF0C2C;

__no_init volatile union
{
  unsigned long QSPIC_BURSTBRK_REG;
  struct
  {
    unsigned long QSPIC_BRK_WRD                   : 16;
    unsigned long QSPIC_BRK_EN                    : 1;
    unsigned long QSPIC_BRK_SZ                    : 1;
    unsigned long QSPIC_BRK_TX_MD                 : 2;
  } QSPIC_BURSTBRK_REG_bit;
} @ 0xFF0C30;

__no_init volatile union
{
  unsigned long QSPIC_STATUSCMD_REG;
  struct
  {
    unsigned long QSPIC_RSTAT_INST                : 8;
    unsigned long QSPIC_RSTAT_TX_MD               : 2;
    unsigned long QSPIC_RSTAT_RX_MD               : 2;
    unsigned long QSPIC_BUSY_POS                  : 3;
    unsigned long QSPIC_BUSY_VAL                  : 1;
    unsigned long QSPIC_RESSTS_DLY                : 6;
    unsigned long QSPIC_STSDLY_SEL                : 1;
  } QSPIC_STATUSCMD_REG_bit;
} @ 0xFF0C34;

__no_init volatile union
{
  unsigned long QSPIC_CHCKERASE_REG;
  struct
  {
    unsigned long QSPIC_CHCKERASE                 : 32;
  } QSPIC_CHCKERASE_REG_bit;
} @ 0xFF0C38;

__no_init volatile union
{
  unsigned short QSPIC_GP_REG;
  struct
  {
    unsigned long AHB_QSPIC_OFFSET                : 2;
    unsigned long QSPIC_MEM_OFFSET                : 3;
    unsigned long QSPI_PIN_CUR                    : 2;
    unsigned long SWITCH_QSPI_SPI                 : 1;
    unsigned long SWITCH_SPI1_SPI2                : 1;
  } QSPIC_GP_REG_bit;
} @ 0xFF0C3C;

__no_init volatile union
{
  unsigned short CLK_AMBA_REG;
  struct
  {
    unsigned short HCLK_DIV                        : 3;
    unsigned short PCLK_DIV                        : 2;
    unsigned short SRAM1_EN                        : 1;
    unsigned short                                 : 1;
    unsigned short MCRAM1_EN                       : 1;
    unsigned short                                 : 1;
    unsigned short HCLK_PRE                        : 1;
    unsigned short                                 : 3;
    unsigned short HCLK_XTAL                       : 1;
  } CLK_AMBA_REG_bit;
} @ 0xFF4000;

__no_init volatile union
{
  unsigned short CLK_CODEC_DIV_REG;
  struct
  {
    unsigned short CODEC_DIV                       : 7;
    unsigned short CODEC_CLK_SEL                   : 2;
  } CLK_CODEC_DIV_REG_bit;
} @ 0xFF4002;

__no_init volatile union
{
  unsigned short CLK_CODEC_REG;
  struct
  {
    unsigned short CLK_MAIN_SEL                    : 2;
    unsigned short CLK_AD_SEL                      : 2;
    unsigned short CLK_DA_CLASSD_SEL               : 2;
    unsigned short CLK_DA_LSR_SEL                  : 2;
    unsigned short CLK_PCM_SEL                     : 2;
    unsigned short CLK_MAIN_EN                     : 1;
    unsigned short CLK_AD_EN                       : 1;
    unsigned short CLK_DA_CLASSD_EN                : 1;
    unsigned short CLK_DA_LSR_EN                   : 1;
    unsigned short CLK_PCM_EN                      : 1;
  } CLK_CODEC_REG_bit;
} @ 0xFF4004;

__no_init volatile union
{
  unsigned short CLK_DSP_REG;
  struct
  {
    unsigned short CLK_DSP_DIV                     : 3;
    unsigned short CLK_DSP_EN                      : 1;
    unsigned short                                 : 4;
    unsigned short CLK_DSP_TIMER_SEL               : 2;
    unsigned short CLK_DSP_TIMER_EN                : 1;
  } CLK_DSP_REG_bit;
} @ 0xFF4006;

__no_init volatile union
{
  unsigned short CLK_FREQ_TRIM_REG;
  struct
  {
    unsigned short FINE_ADJ                        : 8;
    unsigned short COARSE_ADJ                      : 3;
  } CLK_FREQ_TRIM_REG_bit;
} @ 0xFF400A;

__no_init volatile union
{
  unsigned short CLK_PER_DIV_REG;
  struct
  {
    unsigned short PER_DIV                         : 7;
    unsigned short PER_CLK_SEL                     : 2;
  } CLK_PER_DIV_REG_bit;
} @ 0xFF400C;

__no_init volatile union
{
  unsigned short CLK_PER10_DIV_REG;
  struct
  {
    unsigned short PER10_DIV                       : 3;
    unsigned short PER10_CLK_SEL                   : 2;
    unsigned short PER20_DIV                       : 3;
    unsigned short QSPI_DIV                        : 2;
  } CLK_PER10_DIV_REG_bit;
} @ 0xFF400E;

__no_init volatile union
{
  unsigned short CLK_PLL_CTRL_REG;
  struct
  {
    unsigned short TESTMODE_SEL                    : 1;
    unsigned short CP_ON                           : 1;
    unsigned short PLL_OUT_DIV                     : 1;
    unsigned short PLL_CLK_SEL                     : 1;
    unsigned short VCO_ON                          : 1;
    unsigned short                                 : 1;
    unsigned short HF_SEL                          : 1;
    unsigned short PLL_DIP_DIV                     : 4;
    unsigned short DYN_SW                          : 1;
    unsigned short DIV2_CLK_SEL                    : 1;
  } CLK_PLL_CTRL_REG_bit;
} @ 0xFF4010;

__no_init volatile union
{
  unsigned short CLK_PLL_DIV_REG;
  struct
  {
    unsigned short XD1                             : 2;
    unsigned short VD1                             : 3;
  } CLK_PLL_DIV_REG_bit;
} @ 0xFF4012;

__no_init volatile union
{
  unsigned short CLK_XTAL_CTRL_REG;
  struct
  {
    unsigned short OSC300KHZ                       : 1;
    unsigned short XTAL_DIV                        : 1;
  } CLK_XTAL_CTRL_REG_bit;
} @ 0xFF4018;

__no_init volatile union
{
  unsigned short CLK_AUX_REG;
  struct
  {
    unsigned short                                 : 3;
    unsigned short BXTAL_EN                        : 2;
    unsigned short OWI_DIV                         : 2;
    unsigned short OWI_SEL                         : 1;
    unsigned short XDIV                            : 1;
    unsigned short CP_CLK_SEL                      : 1;
    unsigned short CLASSD_FREQ                     : 2;
  } CLK_AUX_REG_bit;
} @ 0xFF401A;

__no_init volatile union
{
  unsigned short CLK_PCM_DIV_REG;
  struct
  {
    unsigned short PCM_DIV                         : 7;
    unsigned short PCM_CLK_SEL                     : 2;
  } CLK_PCM_DIV_REG_bit;
} @ 0xFF401C;

__no_init volatile union
{
  unsigned short CLK_ULP_CTRL_REG;
  struct
  {
    unsigned short XTAL_PD                         : 1;
    unsigned short MAIN_CLK_SEL                    : 1;
    unsigned short CLK300K_DIV                     : 2;
  } CLK_ULP_CTRL_REG_bit;
} @ 0xFF401E;

__no_init volatile unsigned short DMA0_A_STARTL_REG @ 0xFF4400;

__no_init volatile union
{
  unsigned short DMA0_A_STARTH_REG;
  struct
  {
    unsigned short DMAx_A_STARTH                   : 9;
  } DMA0_A_STARTH_REG_bit;
} @ 0xFF4402;

__no_init volatile unsigned short DMA0_B_STARTL_REG @ 0xFF4404;

__no_init volatile union
{
  unsigned short DMA0_B_STARTH_REG;
  struct
  {
    unsigned short DMAx_B_STARTH                   : 9;
  } DMA0_B_STARTH_REG_bit;
} @ 0xFF4406;

__no_init volatile unsigned short DMA0_INT_REG @ 0xFF4408;

__no_init volatile unsigned short DMA0_LEN_REG @ 0xFF440A;

__no_init volatile union
{
  unsigned short DMA0_CTRL_REG;
  struct
  {
    unsigned short DMA_ON                          : 1;
    unsigned short BW                              : 2;
    unsigned short DINT_MODE                       : 1;
    unsigned short DREQ_MODE                       : 1;
    unsigned short BINC                            : 1;
    unsigned short AINC                            : 1;
    unsigned short CIRCULAR                        : 1;
    unsigned short DMA_PRIO                        : 2;
    unsigned short DMA_IDLE                        : 1;
    unsigned short DMA_INIT                        : 1;
  } DMA0_CTRL_REG_bit;
} @ 0xFF440C;

__no_init volatile unsigned short DMA0_IDX_REG @ 0xFF440E;

__no_init volatile unsigned short DMA1_A_STARTL_REG @ 0xFF4410;

__no_init volatile union
{
  unsigned short DMA1_A_STARTH_REG;
  struct
  {
    unsigned short DMAx_A_STARTH                   : 9;
  } DMA1_A_STARTH_REG_bit;
} @ 0xFF4412;

__no_init volatile unsigned short DMA1_B_STARTL_REG @ 0xFF4414;

__no_init volatile union
{
  unsigned short DMA1_B_STARTH_REG;
  struct
  {
    unsigned short DMAx_B_STARTH                   : 9;
  } DMA1_B_STARTH_REG_bit;
} @ 0xFF4416;

__no_init volatile unsigned short DMA1_INT_REG @ 0xFF4418;

__no_init volatile unsigned short DMA1_LEN_REG @ 0xFF441A;

__no_init volatile union
{
  unsigned short DMA1_CTRL_REG;
  struct
  {
    unsigned short DMA_ON                          : 1;
    unsigned short BW                              : 2;
    unsigned short DINT_MODE                       : 1;
    unsigned short DREQ_MODE                       : 1;
    unsigned short BINC                            : 1;
    unsigned short AINC                            : 1;
    unsigned short CIRCULAR                        : 1;
    unsigned short DMA_PRIO                        : 2;
    unsigned short DMA_IDLE                        : 1;
    unsigned short DMA_INIT                        : 1;
  } DMA1_CTRL_REG_bit;
} @ 0xFF441C;

__no_init volatile unsigned short DMA1_IDX_REG @ 0xFF441E;

__no_init volatile unsigned short DMA2_A_STARTL_REG @ 0xFF4420;

__no_init volatile union
{
  unsigned short DMA2_A_STARTH_REG;
  struct
  {
    unsigned short DMAx_A_STARTH                   : 9;
  } DMA2_A_STARTH_REG_bit;
} @ 0xFF4422;

__no_init volatile unsigned short DMA2_B_STARTL_REG @ 0xFF4424;

__no_init volatile union
{
  unsigned short DMA2_B_STARTH_REG;
  struct
  {
    unsigned short DMAx_B_STARTH                   : 9;
  } DMA2_B_STARTH_REG_bit;
} @ 0xFF4426;

__no_init volatile unsigned short DMA2_INT_REG @ 0xFF4428;

__no_init volatile unsigned short DMA2_LEN_REG @ 0xFF442A;

__no_init volatile union
{
  unsigned short DMA2_CTRL_REG;
  struct
  {
    unsigned short DMA_ON                          : 1;
    unsigned short BW                              : 2;
    unsigned short DINT_MODE                       : 1;
    unsigned short DREQ_MODE                       : 1;
    unsigned short BINC                            : 1;
    unsigned short AINC                            : 1;
    unsigned short CIRCULAR                        : 1;
    unsigned short DMA_PRIO                        : 2;
    unsigned short DMA_IDLE                        : 1;
    unsigned short DMA_INIT                        : 1;
  } DMA2_CTRL_REG_bit;
} @ 0xFF442C;

__no_init volatile unsigned short DMA2_IDX_REG @ 0xFF442E;

__no_init volatile unsigned short DMA3_A_STARTL_REG @ 0xFF4430;

__no_init volatile union
{
  unsigned short DMA3_A_STARTH_REG;
  struct
  {
    unsigned short DMAx_A_STARTH                   : 9;
  } DMA3_A_STARTH_REG_bit;
} @ 0xFF4432;

__no_init volatile unsigned short DMA3_B_STARTL_REG @ 0xFF4434;

__no_init volatile union
{
  unsigned short DMA3_B_STARTH_REG;
  struct
  {
    unsigned short DMAx_B_STARTH                   : 9;
  } DMA3_B_STARTH_REG_bit;
} @ 0xFF4436;

__no_init volatile unsigned short DMA3_INT_REG @ 0xFF4438;

__no_init volatile unsigned short DMA3_LEN_REG @ 0xFF443A;

__no_init volatile union
{
  unsigned short DMA3_CTRL_REG;
  struct
  {
    unsigned short DMA_ON                          : 1;
    unsigned short BW                              : 2;
    unsigned short DINT_MODE                       : 1;
    unsigned short DREQ_MODE                       : 1;
    unsigned short BINC                            : 1;
    unsigned short AINC                            : 1;
    unsigned short CIRCULAR                        : 1;
    unsigned short DMA_PRIO                        : 2;
    unsigned short DMA_IDLE                        : 1;
    unsigned short DMA_INIT                        : 1;
  } DMA3_CTRL_REG_bit;
} @ 0xFF443C;

__no_init volatile unsigned short DMA3_IDX_REG @ 0xFF443E;

__no_init volatile union
{
  unsigned short TEST_ENV_REG;
  struct
  {
    unsigned short BOOT                            : 1;
    unsigned short                                 : 1;
    unsigned short ENV_SDI_W                       : 1;
    unsigned short                                 : 1;
    unsigned short ENV_SDI                         : 1;
    unsigned short ENV_REG7_5                      : 3;
  } TEST_ENV_REG_bit;
} @ 0xFF4800;

__no_init volatile unsigned short TEST_CTRL_REG @ 0xFF4802;

__no_init volatile unsigned short TEST_CTRL2_REG @ 0xFF4804;

__no_init volatile unsigned short TEST_CTRL3_REG @ 0xFF4806;

__no_init volatile unsigned short TEST_CTRL4_REG @ 0xFF4808;

__no_init volatile union
{
  unsigned short BANDGAP_REG;
  struct
  {
    unsigned short BANDGAP_VI                      : 4;
    unsigned short BANDGAP_VIT                     : 2;
    unsigned short BANDGAP_I                       : 3;
  } BANDGAP_REG_bit;
} @ 0xFF4810;

__no_init volatile union
{
  unsigned short BAT_CTRL_REG;
  struct
  {
    unsigned short REG_ON                          : 1;
    unsigned short LDORF_ON                        : 1;
    unsigned short LDORF_LEVEL                     : 2;
    unsigned short VBATC_LEVEL                     : 2;
    unsigned short VBATC_OUTPUT                    : 1;
    unsigned short DC_ON                           : 2;
    unsigned short DC_MODE_2                       : 2;
    unsigned short DC_HYST                         : 1;
    unsigned short DC_MODE_1                       : 1;
    unsigned short DC_FREQ                         : 2;
    unsigned short DC_CLK_SEL                      : 1;
  } BAT_CTRL_REG_bit;
} @ 0xFF4812;

__no_init volatile union
{
  unsigned short BAT_CTRL2_REG;
  struct
  {
    unsigned short CHARGE_LEVEL                    : 5;
    unsigned short CHARGE_ON                       : 1;
    unsigned short NTC_DISABLE                     : 1;
    unsigned short ONE_CELL                        : 1;
    unsigned short CHARGE_CUR                      : 3;
    unsigned short SOC_ON                          : 1;
    unsigned short SOC_CAL                         : 1;
    unsigned short SOC_TEST1                       : 1;
    unsigned short SOC_TEST2                       : 1;
    unsigned short STATUS_MODE                     : 1;
  } BAT_CTRL2_REG_bit;
} @ 0xFF4814;

__no_init volatile union
{
  unsigned short BAT_STATUS_REG;
  struct
  {
    unsigned short VBAT3_STS                       : 1;
    unsigned short PON_STS                         : 1;
    unsigned short CHARGE_STS                      : 1;
    unsigned short CHARGE_I_LIMIT                  : 1;
  } BAT_STATUS_REG_bit;
} @ 0xFF4816;

__no_init volatile unsigned short BAT_SOC_HIGH_REG @ 0xFF4818;

__no_init volatile unsigned short BAT_SOC_LOW_REG @ 0xFF481A;

__no_init volatile union
{
  unsigned short CP_CTRL_REG;
  struct
  {
    unsigned short CP_EN                           : 2;
    unsigned short CP_LEVEL1                       : 2;
    unsigned short CP_LEVEL2                       : 2;
    unsigned short CP_PWM1                         : 1;
    unsigned short CP_PWM2                         : 1;
    unsigned short CP_FREQ                         : 2;
    unsigned short CP_PARALLEL                     : 1;
    unsigned short CP_MODE                         : 1;
    unsigned short CP_TEST_ADC1                    : 1;
    unsigned short CP_TEST_ADC2                    : 1;
    unsigned short CP_FORCE_MODE                   : 2;
  } CP_CTRL_REG_bit;
} @ 0xFF481C;

__no_init volatile union
{
  unsigned short PAD_CTRL_REG;
  struct
  {
    unsigned short P04567_OD                       : 1;
    unsigned short P023_OD                         : 1;
    unsigned short P001_OD                         : 1;
    unsigned short P27_OD                          : 1;
    unsigned short P225_OD                         : 1;
    unsigned short P234_OD                         : 1;
    unsigned short P21_OD                          : 1;
    unsigned short P20_OD                          : 1;
    unsigned short LED3_CUR                        : 1;
    unsigned short LED4_CUR                        : 1;
    unsigned short P4_OD                           : 1;
    unsigned short P5_OD                           : 1;
    unsigned short LED3_PWM                        : 1;
    unsigned short LED4_PWM                        : 1;
    unsigned short LED34_C_MODE                    : 1;
  } PAD_CTRL_REG_bit;
} @ 0xFF481E;

__no_init volatile union
{
  unsigned short LED_CTRL_REG;
  struct
  {
    unsigned short WLED_CUR0                       : 2;
    unsigned short WLED_CUR1                       : 2;
    unsigned short WLED_CUR2                       : 2;
    unsigned short WLED0_PWM                       : 1;
    unsigned short WLED1_PWM                       : 1;
    unsigned short WLED2_PWM                       : 1;
    unsigned short WLED_PWM_CTRL                   : 1;
  } LED_CTRL_REG_bit;
} @ 0xFF4820;

__no_init volatile union
{
  unsigned short P0_DATA_REG;
  struct
  {
    unsigned short Px_0_DATA                       : 1;
    unsigned short Px_1_DATA                       : 1;
    unsigned short Px_2_DATA                       : 1;
    unsigned short Px_3_DATA                       : 1;
    unsigned short Px_4_DATA                       : 1;
    unsigned short Px_5_DATA                       : 1;
    unsigned short Px_6_DATA                       : 1;
    unsigned short Px_7_DATA                       : 1;
  } P0_DATA_REG_bit;
} @ 0xFF4830;

__no_init volatile union
{
  unsigned short P0_SET_DATA_REG;
  struct
  {
    unsigned short Px_0_SET                        : 1;
    unsigned short Px_1_SET                        : 1;
    unsigned short Px_2_SET                        : 1;
    unsigned short Px_3_SET                        : 1;
    unsigned short Px_4_SET                        : 1;
    unsigned short Px_5_SET                        : 1;
    unsigned short Px_6_SET                        : 1;
    unsigned short Px_7_SET                        : 1;
  } P0_SET_DATA_REG_bit;
} @ 0xFF4832;

__no_init volatile union
{
  unsigned short P0_RESET_DATA_REG;
  struct
  {
    unsigned short Px_0_RESET                      : 1;
    unsigned short Px_1_RESET                      : 1;
    unsigned short Px_2_RESET                      : 1;
    unsigned short Px_3_RESET                      : 1;
    unsigned short Px_4_RESET                      : 1;
    unsigned short Px_5_RESET                      : 1;
    unsigned short Px_6_RESET                      : 1;
    unsigned short Px_7_RESET                      : 1;
  } P0_RESET_DATA_REG_bit;
} @ 0xFF4834;

__no_init volatile union
{
  unsigned short P0_DIR_REG;
  struct
  {
    unsigned short Px_0_DIR                        : 2;
    unsigned short Px_1_DIR                        : 2;
    unsigned short Px_2_DIR                        : 2;
    unsigned short Px_3_DIR                        : 2;
    unsigned short Px_4_DIR                        : 2;
    unsigned short Px_5_DIR                        : 2;
    unsigned short Px_6_DIR                        : 2;
    unsigned short Px_7_DIR                        : 2;
  } P0_DIR_REG_bit;
} @ 0xFF4836;

__no_init volatile union
{
  unsigned short P0_MODE_REG;
  struct
  {
    unsigned short P0_0_MODE                       : 1;
    unsigned short P0_1_MODE                       : 1;
    unsigned short P0_2_MODE                       : 2;
    unsigned short P0_3_MODE                       : 2;
    unsigned short P0_4_MODE                       : 2;
    unsigned short P0_5_MODE                       : 2;
    unsigned short P0_6_MODE                       : 2;
    unsigned short P0_7_MODE                       : 2;
  } P0_MODE_REG_bit;
} @ 0xFF4838;

__no_init volatile union
{
  unsigned short P1_DATA_REG;
  struct
  {
    unsigned short Px_0_DATA                       : 1;
    unsigned short Px_1_DATA                       : 1;
    unsigned short Px_2_DATA                       : 1;
    unsigned short Px_3_DATA                       : 1;
    unsigned short Px_4_DATA                       : 1;
    unsigned short Px_5_DATA                       : 1;
    unsigned short Px_6_DATA                       : 1;
    unsigned short Px_7_DATA                       : 1;
  } P1_DATA_REG_bit;
} @ 0xFF4840;

__no_init volatile union
{
  unsigned short P1_SET_DATA_REG;
  struct
  {
    unsigned short Px_0_SET                        : 1;
    unsigned short Px_1_SET                        : 1;
    unsigned short Px_2_SET                        : 1;
    unsigned short Px_3_SET                        : 1;
    unsigned short Px_4_SET                        : 1;
    unsigned short Px_5_SET                        : 1;
    unsigned short Px_6_SET                        : 1;
    unsigned short Px_7_SET                        : 1;
  } P1_SET_DATA_REG_bit;
} @ 0xFF4842;

__no_init volatile union
{
  unsigned short P1_RESET_DATA_REG;
  struct
  {
    unsigned short Px_0_RESET                      : 1;
    unsigned short Px_1_RESET                      : 1;
    unsigned short Px_2_RESET                      : 1;
    unsigned short Px_3_RESET                      : 1;
    unsigned short Px_4_RESET                      : 1;
    unsigned short Px_5_RESET                      : 1;
    unsigned short Px_6_RESET                      : 1;
    unsigned short Px_7_RESET                      : 1;
  } P1_RESET_DATA_REG_bit;
} @ 0xFF4844;

__no_init volatile union
{
  unsigned short P1_DIR_REG;
  struct
  {
    unsigned short Px_0_DIR                        : 2;
    unsigned short Px_1_DIR                        : 2;
    unsigned short Px_2_DIR                        : 2;
    unsigned short Px_3_DIR                        : 2;
    unsigned short Px_4_DIR                        : 2;
    unsigned short Px_5_DIR                        : 2;
    unsigned short Px_6_DIR                        : 2;
    unsigned short Px_7_DIR                        : 2;
  } P1_DIR_REG_bit;
} @ 0xFF4846;

__no_init volatile union
{
  unsigned short P1_MODE_REG;
  struct
  {
    unsigned short P1_0_MODE                       : 1;
    unsigned short P1_1_MODE                       : 1;
    unsigned short P1_2_MODE                       : 1;
    unsigned short P1_3_MODE                       : 1;
    unsigned short P1_4_MODE                       : 1;
    unsigned short P1_5_MODE                       : 3;
    unsigned short RF_BB_MODE                      : 2;
  } P1_MODE_REG_bit;
} @ 0xFF4848;

__no_init volatile union
{
  unsigned short P2_DATA_REG;
  struct
  {
    unsigned short Px_0_DATA                       : 1;
    unsigned short Px_1_DATA                       : 1;
    unsigned short Px_2_DATA                       : 1;
    unsigned short Px_3_DATA                       : 1;
    unsigned short Px_4_DATA                       : 1;
    unsigned short Px_5_DATA                       : 1;
    unsigned short Px_6_DATA                       : 1;
    unsigned short Px_7_DATA                       : 1;
  } P2_DATA_REG_bit;
} @ 0xFF4850;

__no_init volatile union
{
  unsigned short P2_SET_DATA_REG;
  struct
  {
    unsigned short Px_0_SET                        : 1;
    unsigned short Px_1_SET                        : 1;
    unsigned short Px_2_SET                        : 1;
    unsigned short Px_3_SET                        : 1;
    unsigned short Px_4_SET                        : 1;
    unsigned short Px_5_SET                        : 1;
    unsigned short Px_6_SET                        : 1;
    unsigned short Px_7_SET                        : 1;
  } P2_SET_DATA_REG_bit;
} @ 0xFF4852;

__no_init volatile union
{
  unsigned short P2_RESET_DATA_REG;
  struct
  {
    unsigned short Px_0_RESET                      : 1;
    unsigned short Px_1_RESET                      : 1;
    unsigned short Px_2_RESET                      : 1;
    unsigned short Px_3_RESET                      : 1;
    unsigned short Px_4_RESET                      : 1;
    unsigned short Px_5_RESET                      : 1;
    unsigned short Px_6_RESET                      : 1;
    unsigned short Px_7_RESET                      : 1;
  } P2_RESET_DATA_REG_bit;
} @ 0xFF4854;

__no_init volatile union
{
  unsigned short P2_DIR_REG;
  struct
  {
    unsigned short Px_0_DIR                        : 2;
    unsigned short Px_1_DIR                        : 2;
    unsigned short Px_2_DIR                        : 2;
    unsigned short Px_3_DIR                        : 2;
    unsigned short Px_4_DIR                        : 2;
    unsigned short Px_5_DIR                        : 2;
    unsigned short Px_6_DIR                        : 2;
    unsigned short Px_7_DIR                        : 2;
  } P2_DIR_REG_bit;
} @ 0xFF4856;

__no_init volatile union
{
  unsigned short P2_MODE_REG;
  struct
  {
    unsigned short P2_0_MODE                       : 2;
    unsigned short P2_1_MODE                       : 2;
    unsigned short P2_2_MODE                       : 2;
    unsigned short P2_3_MODE                       : 2;
    unsigned short P2_4_MODE                       : 2;
    unsigned short P2_5_MODE                       : 2;
    unsigned short INT6_MODE                       : 1;
    unsigned short P2_6_MODE                       : 1;
    unsigned short INT7_MODE                       : 1;
    unsigned short P2_7_MODE                       : 1;
  } P2_MODE_REG_bit;
} @ 0xFF4858;

__no_init volatile union
{
  unsigned short P3_DATA_REG;
  struct
  {
    unsigned short Px_0_DATA                       : 1;
    unsigned short Px_1_DATA                       : 1;
    unsigned short Px_2_DATA                       : 1;
    unsigned short Px_3_DATA                       : 1;
    unsigned short Px_4_DATA                       : 1;
    unsigned short Px_5_DATA                       : 1;
    unsigned short Px_6_DATA                       : 1;
    unsigned short Px_7_DATA                       : 1;
  } P3_DATA_REG_bit;
} @ 0xFF4860;

__no_init volatile union
{
  unsigned short P3_SET_DATA_REG;
  struct
  {
    unsigned short Px_0_SET                        : 1;
    unsigned short Px_1_SET                        : 1;
    unsigned short Px_2_SET                        : 1;
    unsigned short Px_3_SET                        : 1;
    unsigned short Px_4_SET                        : 1;
    unsigned short Px_5_SET                        : 1;
    unsigned short Px_6_SET                        : 1;
    unsigned short Px_7_SET                        : 1;
  } P3_SET_DATA_REG_bit;
} @ 0xFF4862;

__no_init volatile union
{
  unsigned short P3_RESET_DATA_REG;
  struct
  {
    unsigned short Px_0_RESET                      : 1;
    unsigned short Px_1_RESET                      : 1;
    unsigned short Px_2_RESET                      : 1;
    unsigned short Px_3_RESET                      : 1;
    unsigned short Px_4_RESET                      : 1;
    unsigned short Px_5_RESET                      : 1;
    unsigned short Px_6_RESET                      : 1;
    unsigned short Px_7_RESET                      : 1;
  } P3_RESET_DATA_REG_bit;
} @ 0xFF4864;

__no_init volatile union
{
  unsigned short P3_DIR_REG;
  struct
  {
    unsigned short Px_0_DIR                        : 2;
    unsigned short Px_1_DIR                        : 2;
    unsigned short Px_2_DIR                        : 2;
    unsigned short Px_3_DIR                        : 2;
    unsigned short Px_4_DIR                        : 2;
    unsigned short Px_5_DIR                        : 2;
    unsigned short Px_6_DIR                        : 2;
    unsigned short Px_7_DIR                        : 2;
  } P3_DIR_REG_bit;
} @ 0xFF4866;

__no_init volatile union
{
  unsigned short P3_MODE_REG;
  struct
  {
    unsigned short P3_0_MODE                       : 2;
    unsigned short P3_1_MODE                       : 2;
    unsigned short P3_2_MODE                       : 2;
    unsigned short P3_3_MODE                       : 2;
    unsigned short P3_4_MODE                       : 2;
    unsigned short P3_5_MODE                       : 2;
    unsigned short P3_6_MODE                       : 2;
    unsigned short P3_7_MODE                       : 2;
  } P3_MODE_REG_bit;
} @ 0xFF4868;

__no_init volatile union
{
  unsigned short P4_DATA_REG;
  struct
  {
    unsigned short Px_0_DATA                       : 1;
    unsigned short Px_1_DATA                       : 1;
    unsigned short Px_2_DATA                       : 1;
    unsigned short Px_3_DATA                       : 1;
    unsigned short Px_4_DATA                       : 1;
    unsigned short Px_5_DATA                       : 1;
    unsigned short Px_6_DATA                       : 1;
    unsigned short Px_7_DATA                       : 1;
  } P4_DATA_REG_bit;
} @ 0xFF4870;

__no_init volatile union
{
  unsigned short P4_SET_DATA_REG;
  struct
  {
    unsigned short Px_0_SET                        : 1;
    unsigned short Px_1_SET                        : 1;
    unsigned short Px_2_SET                        : 1;
    unsigned short Px_3_SET                        : 1;
    unsigned short Px_4_SET                        : 1;
    unsigned short Px_5_SET                        : 1;
    unsigned short Px_6_SET                        : 1;
    unsigned short Px_7_SET                        : 1;
  } P4_SET_DATA_REG_bit;
} @ 0xFF4872;

__no_init volatile union
{
  unsigned short P4_RESET_DATA_REG;
  struct
  {
    unsigned short Px_0_RESET                      : 1;
    unsigned short Px_1_RESET                      : 1;
    unsigned short Px_2_RESET                      : 1;
    unsigned short Px_3_RESET                      : 1;
    unsigned short Px_4_RESET                      : 1;
    unsigned short Px_5_RESET                      : 1;
    unsigned short Px_6_RESET                      : 1;
    unsigned short Px_7_RESET                      : 1;
  } P4_RESET_DATA_REG_bit;
} @ 0xFF4874;

__no_init volatile union
{
  unsigned short P4_DIR_REG;
  struct
  {
    unsigned short Px_0_DIR                        : 2;
    unsigned short Px_1_DIR                        : 2;
    unsigned short Px_2_DIR                        : 2;
    unsigned short Px_3_DIR                        : 2;
    unsigned short Px_4_DIR                        : 2;
    unsigned short Px_5_DIR                        : 2;
    unsigned short Px_6_DIR                        : 2;
    unsigned short Px_7_DIR                        : 2;
  } P4_DIR_REG_bit;
} @ 0xFF4876;

__no_init volatile union
{
  unsigned short P4_MODE_REG;
  struct
  {
    unsigned short P4_2_MODE                       : 1;
    unsigned short P4_1_MODE                       : 1;
  } P4_MODE_REG_bit;
} @ 0xFF4878;

__no_init volatile union
{
  unsigned short P5_DATA_REG;
  struct
  {
    unsigned short Px_0_DATA                       : 1;
    unsigned short Px_1_DATA                       : 1;
    unsigned short Px_2_DATA                       : 1;
    unsigned short Px_3_DATA                       : 1;
    unsigned short Px_4_DATA                       : 1;
    unsigned short Px_5_DATA                       : 1;
    unsigned short Px_6_DATA                       : 1;
    unsigned short Px_7_DATA                       : 1;
  } P5_DATA_REG_bit;
} @ 0xFF4880;

__no_init volatile union
{
  unsigned short P5_SET_DATA_REG;
  struct
  {
    unsigned short Px_0_SET                        : 1;
    unsigned short Px_1_SET                        : 1;
    unsigned short Px_2_SET                        : 1;
    unsigned short Px_3_SET                        : 1;
    unsigned short Px_4_SET                        : 1;
    unsigned short Px_5_SET                        : 1;
    unsigned short Px_6_SET                        : 1;
    unsigned short Px_7_SET                        : 1;
  } P5_SET_DATA_REG_bit;
} @ 0xFF4882;

__no_init volatile union
{
  unsigned short P5_RESET_DATA_REG;
  struct
  {
    unsigned short Px_0_RESET                      : 1;
    unsigned short Px_1_RESET                      : 1;
    unsigned short Px_2_RESET                      : 1;
    unsigned short Px_3_RESET                      : 1;
    unsigned short Px_4_RESET                      : 1;
    unsigned short Px_5_RESET                      : 1;
    unsigned short Px_6_RESET                      : 1;
    unsigned short Px_7_RESET                      : 1;
  } P5_RESET_DATA_REG_bit;
} @ 0xFF4884;

__no_init volatile union
{
  unsigned short P5_DIR_REG;
  struct
  {
    unsigned short Px_0_DIR                        : 2;
    unsigned short Px_1_DIR                        : 2;
    unsigned short Px_2_DIR                        : 2;
    unsigned short Px_3_DIR                        : 2;
    unsigned short Px_4_DIR                        : 2;
    unsigned short Px_5_DIR                        : 2;
    unsigned short Px_6_DIR                        : 2;
    unsigned short Px_7_DIR                        : 2;
  } P5_DIR_REG_bit;
} @ 0xFF4886;

__no_init volatile union
{
  unsigned short P5_MODE_REG;
  struct
  {
    unsigned short P5_MODE                         : 5;
  } P5_MODE_REG_bit;
} @ 0xFF4888;

__no_init volatile union
{
  unsigned short PORT_TRACE_CTRL_REG;
  struct
  {
    unsigned short TRACE_EXT0                      : 5;
    unsigned short TRACE_EXT1                      : 5;
  } PORT_TRACE_CTRL_REG_bit;
} @ 0xFF48E0;

__no_init volatile union
{
  unsigned short UART_CTRL_REG;
  struct
  {
    unsigned short UART_REN                        : 1;
    unsigned short UART_TEN                        : 1;
    unsigned short BAUDRATE                        : 3;
    unsigned short TI                              : 1;
    unsigned short RI                              : 1;
    unsigned short UART_MODE                       : 1;
    unsigned short IRDA_EN                         : 1;
    unsigned short INV_URX                         : 1;
    unsigned short INV_UTX                         : 1;
  } UART_CTRL_REG_bit;
} @ 0xFF4900;

__no_init volatile unsigned short UART_RX_TX_REG @ 0xFF4902;

__no_init volatile unsigned short UART_CLEAR_TX_INT_REG @ 0xFF4904;

__no_init volatile unsigned short UART_CLEAR_RX_INT_REG @ 0xFF4906;

__no_init volatile union
{
  unsigned short UART_ERROR_REG;
  struct
  {
    unsigned short PAR_STATUS                      : 1;
    unsigned short DMA_PARITY_ERROR                : 1;
  } UART_ERROR_REG_bit;
} @ 0xFF4908;

__no_init volatile union
{
  unsigned short UART2_CTRL_REG;
  struct
  {
    unsigned short UART_REN                        : 1;
    unsigned short UART_TEN                        : 1;
    unsigned short BAUDRATE                        : 3;
    unsigned short TI                              : 1;
    unsigned short RI                              : 1;
    unsigned short UART_MODE                       : 1;
    unsigned short IRDA_EN                         : 1;
    unsigned short INV_URX                         : 1;
    unsigned short INV_UTX                         : 1;
  } UART2_CTRL_REG_bit;
} @ 0xFF4910;

__no_init volatile unsigned short UART2_RX_TX_REG @ 0xFF4912;

__no_init volatile unsigned short UART2_CLEAR_TX_INT_REG @ 0xFF4914;

__no_init volatile unsigned short UART2_CLEAR_RX_INT_REG @ 0xFF4916;

__no_init volatile union
{
  unsigned short UART2_ERROR_REG;
  struct
  {
    unsigned short PAR_STATUS                      : 1;
    unsigned short DMA_PARITY_ERROR                : 1;
  } UART2_ERROR_REG_bit;
} @ 0xFF4918;

__no_init volatile unsigned short ACCESS1_IN_OUT_REG @ 0xFF4920;

__no_init volatile union
{
  unsigned short ACCESS1_CTRL_REG;
  struct
  {
    unsigned short EN_ACCESS_BUS                   : 1;
    unsigned short ACKn                            : 1;
    unsigned short SCL_VAL                         : 1;
    unsigned short SDA_VAL                         : 1;
    unsigned short ACCESSx_INT                     : 1;
    unsigned short EN_ACCESS_INT                   : 1;
    unsigned short SCL_OD                          : 1;
    unsigned short SDA_OD                          : 1;
    unsigned short SCK_NUM                         : 1;
    unsigned short SCK_SEL                         : 2;
  } ACCESS1_CTRL_REG_bit;
} @ 0xFF4922;

__no_init volatile unsigned short ACCESS1_CLEAR_INT_REG @ 0xFF4924;

__no_init volatile unsigned short ACCESS2_IN_OUT_REG @ 0xFF4930;

__no_init volatile union
{
  unsigned short ACCESS2_CTRL_REG;
  struct
  {
    unsigned short EN_ACCESS_BUS                   : 1;
    unsigned short ACKn                            : 1;
    unsigned short SCL_VAL                         : 1;
    unsigned short SDA_VAL                         : 1;
    unsigned short ACCESSx_INT                     : 1;
    unsigned short EN_ACCESS_INT                   : 1;
    unsigned short SCL_OD                          : 1;
    unsigned short SDA_OD                          : 1;
    unsigned short SCK_NUM                         : 1;
    unsigned short SCK_SEL                         : 2;
  } ACCESS2_CTRL_REG_bit;
} @ 0xFF4932;

__no_init volatile unsigned short ACCESS2_CLEAR_INT_REG @ 0xFF4934;

__no_init volatile union
{
  unsigned short SPI_CTRL_REG;
  struct
  {
    unsigned short SPI_ON                          : 1;
    unsigned short SPI_PHA                         : 1;
    unsigned short SPI_POL                         : 1;
    unsigned short SPI_CLK                         : 2;
    unsigned short SPI_DO                          : 1;
    unsigned short SPI_SMN                         : 1;
    unsigned short SPI_WORD                        : 2;
    unsigned short SPI_RST                         : 1;
    unsigned short SPI_FORCE_DO                    : 1;
    unsigned short SPI_TXH                         : 1;
    unsigned short SPI_DI                          : 1;
    unsigned short SPI_INT_BIT                     : 1;
    unsigned short SPI_MINT                        : 1;
    unsigned short SPI_EN_CTRL                     : 1;
  } SPI_CTRL_REG_bit;
} @ 0xFF4940;

__no_init volatile unsigned short SPI_RX_TX_REG0 @ 0xFF4942;

__no_init volatile unsigned short SPI_RX_TX_REG1 @ 0xFF4944;

__no_init volatile unsigned short SPI_CLEAR_INT_REG @ 0xFF4946;

__no_init volatile union
{
  unsigned short SPI_CTRL_REG1;
  struct
  {
    unsigned short SPI_FIFO_MODE                   : 2;
    unsigned short SPI_PRIORITY                    : 1;
    unsigned short SPI_BUSY                        : 1;
  } SPI_CTRL_REG1_bit;
} @ 0xFF4948;

__no_init volatile union
{
  unsigned short SPI2_CTRL_REG;
  struct
  {
    unsigned short SPI_ON                          : 1;
    unsigned short SPI_PHA                         : 1;
    unsigned short SPI_POL                         : 1;
    unsigned short SPI_CLK                         : 2;
    unsigned short SPI_DO                          : 1;
    unsigned short SPI_SMN                         : 1;
    unsigned short SPI_WORD                        : 2;
    unsigned short SPI_RST                         : 1;
    unsigned short SPI_FORCE_DO                    : 1;
    unsigned short SPI_TXH                         : 1;
    unsigned short SPI_DI                          : 1;
    unsigned short SPI_INT_BIT                     : 1;
    unsigned short SPI_MINT                        : 1;
    unsigned short SPI_EN_CTRL                     : 1;
  } SPI2_CTRL_REG_bit;
} @ 0xFF4950;

__no_init volatile unsigned short SPI2_RX_TX_REG0 @ 0xFF4952;

__no_init volatile unsigned short SPI2_RX_TX_REG1 @ 0xFF4954;

__no_init volatile unsigned short SPI2_CLEAR_INT_REG @ 0xFF4956;

__no_init volatile union
{
  unsigned short SPI2_CTRL_REG1;
  struct
  {
    unsigned short SPI_FIFO_MODE                   : 2;
    unsigned short SPI_PRIORITY                    : 1;
    unsigned short SPI_BUSY                        : 1;
  } SPI2_CTRL_REG1_bit;
} @ 0xFF4958;

__no_init volatile union
{
  unsigned short ADC_CTRL_REG;
  struct
  {
    unsigned short ADC_START                       : 1;
    unsigned short                                 : 1;
    unsigned short ADC_ALT                         : 1;
    unsigned short ADC_IN_3_0                      : 4;
    unsigned short ADC_TEST                        : 4;
    unsigned short ADC_INT                         : 1;
    unsigned short ADC_MINT                        : 1;
    unsigned short ADC0_PR_DIS                     : 1;
    unsigned short ADC1_PR_DIS                     : 1;
    unsigned short ADC2_PR_DIS                     : 1;
  } ADC_CTRL_REG_bit;
} @ 0xFF4960;

__no_init volatile union
{
  unsigned short ADC_CTRL1_REG;
  struct
  {
    unsigned short ADC_IN_3_0_1                    : 4;
  } ADC_CTRL1_REG_bit;
} @ 0xFF4962;

__no_init volatile unsigned short ADC_CLEAR_INT_REG @ 0xFF4964;

__no_init volatile union
{
  unsigned short ADC0_REG;
  struct
  {
    unsigned short ADC0_VAL                        : 10;
  } ADC0_REG_bit;
} @ 0xFF4966;

__no_init volatile union
{
  unsigned short ADC1_REG;
  struct
  {
    unsigned short ADC1_VAL                        : 10;
  } ADC1_REG_bit;
} @ 0xFF4968;

__no_init volatile union
{
  unsigned short TIMER_CTRL_REG;
  struct
  {
    unsigned short TIM0_CTRL                       : 1;
    unsigned short TIM1_CTRL                       : 1;
    unsigned short CLK_CTRL0                       : 1;
    unsigned short CLK_CTRL1                       : 1;
    unsigned short WDOG_CTRL                       : 1;
    unsigned short TIM1_MODE                       : 1;
    unsigned short CLK_DIV8                        : 1;
    unsigned short TIM2_CTRL                       : 1;
  } TIMER_CTRL_REG_bit;
} @ 0xFF4970;

__no_init volatile unsigned short TIMER0_ON_REG @ 0xFF4972;

__no_init volatile unsigned short TIMER0_RELOAD_M_REG @ 0xFF4974;

__no_init volatile unsigned short TIMER0_RELOAD_N_REG @ 0xFF4976;

__no_init volatile unsigned short TIMER1_RELOAD_M_REG @ 0xFF4978;

__no_init volatile unsigned short TIMER1_RELOAD_N_REG @ 0xFF497A;

__no_init volatile union
{
  unsigned short TIMER2_DUTY1_REG;
  struct
  {
    unsigned short TIM2_DUTY1                      : 14;
  } TIMER2_DUTY1_REG_bit;
} @ 0xFF497C;

__no_init volatile union
{
  unsigned short TIMER2_DUTY2_REG;
  struct
  {
    unsigned short TIM2_DUTY2                      : 14;
  } TIMER2_DUTY2_REG_bit;
} @ 0xFF497E;

__no_init volatile union
{
  unsigned short TIMER2_FREQ_REG;
  struct
  {
    unsigned short TIM2_FREQ                       : 14;
  } TIMER2_FREQ_REG_bit;
} @ 0xFF4980;

__no_init volatile union
{
  unsigned short TIMER2_DUTY3_REG;
  struct
  {
    unsigned short TIM2_DUTY3                      : 14;
  } TIMER2_DUTY3_REG_bit;
} @ 0xFF4982;

__no_init volatile union
{
  unsigned short TONE_CTRL1_REG;
  struct
  {
    unsigned short GATESRC1                        : 2;
    unsigned short CLKSRC1                         : 2;
    unsigned short TIMER_RELOAD1                   : 4;
    unsigned short CT1_INT                         : 1;
    unsigned short MCT1_INT                        : 1;
    unsigned short GATE_EDGE1                      : 1;
  } TONE_CTRL1_REG_bit;
} @ 0xFF4990;

__no_init volatile unsigned short TONE_COUNTER1_REG @ 0xFF4992;

__no_init volatile unsigned short TONE_LATCH1_REG @ 0xFF4994;

__no_init volatile unsigned short TONE_CLEAR_INT1_REG @ 0xFF4996;

__no_init volatile union
{
  unsigned short TONE_CTRL2_REG;
  struct
  {
    unsigned short GATESRC2                        : 2;
    unsigned short CLKSRC2                         : 2;
    unsigned short TIMER_RELOAD2                   : 4;
    unsigned short CT2_INT                         : 1;
    unsigned short MCT2_INT                        : 1;
    unsigned short GATE_EDGE2                      : 1;
  } TONE_CTRL2_REG_bit;
} @ 0xFF4998;

__no_init volatile unsigned short TONE_COUNTER2_REG @ 0xFF499A;

__no_init volatile unsigned short TONE_LATCH2_REG @ 0xFF499C;

__no_init volatile unsigned short TONE_CLEAR_INT2_REG @ 0xFF499E;

__no_init volatile union
{
  unsigned short KEY_GP_INT_REG;
  struct
  {
    unsigned short INT6_CTRL                       : 3;
    unsigned short INT7_CTRL                       : 3;
    unsigned short INT8_CTRL                       : 3;
  } KEY_GP_INT_REG_bit;
} @ 0xFF49B0;

__no_init volatile union
{
  unsigned short KEY_BOARD_INT_REG;
  struct
  {
    unsigned short INT0_EN                         : 1;
    unsigned short INT1_EN                         : 1;
    unsigned short INT2_EN                         : 1;
    unsigned short INT3_EN                         : 1;
    unsigned short INT4_EN                         : 1;
    unsigned short INT5_EN                         : 1;
    unsigned short INT_CHARGE_EN                   : 1;
    unsigned short INT_PON_EN                      : 1;
    unsigned short CHARGE_CTRL                     : 1;
    unsigned short PON_CTRL                        : 1;
    unsigned short KEY_LEVEL                       : 1;
    unsigned short KEY_REL                         : 1;
    unsigned short CHARGE_EDGE                     : 1;
    unsigned short VBATC_EDGE                      : 1;
    unsigned short VBATC_EN                        : 1;
  } KEY_BOARD_INT_REG_bit;
} @ 0xFF49B2;

__no_init volatile union
{
  unsigned short KEY_DEBOUNCE_REG;
  struct
  {
    unsigned short DEBOUNCE                        : 6;
    unsigned short KEY_REPEAT                      : 6;
  } KEY_DEBOUNCE_REG_bit;
} @ 0xFF49B4;

__no_init volatile union
{
  unsigned short KEY_STATUS_REG;
  struct
  {
    unsigned short KEY_STATUS                      : 5;
  } KEY_STATUS_REG_bit;
} @ 0xFF49B6;

__no_init volatile union
{
  unsigned short ULP_CTRL_REG;
  struct
  {
    unsigned short ULP_ENABLE                      : 1;
    unsigned short ULP_MAIN_SLEEP                  : 1;
    unsigned short ULP_TIMER_ON                    : 1;
    unsigned short ULP_TIMER_WEN                   : 1;
    unsigned short ULP_TIMER_REN                   : 1;
    unsigned short ULP_TRIG_EN                     : 1;
    unsigned short ULP_XTAL_ON                     : 1;
    unsigned short ULP_OSC_ON                      : 1;
    unsigned short ULP_CLK_SEL                     : 1;
    unsigned short ULP_LATCH_CNT                   : 1;
  } ULP_CTRL_REG_bit;
} @ 0xFF4A00;

__no_init volatile union
{
  unsigned short ULP_TRIG_REG;
  struct
  {
    unsigned short ULP_TRIG                        : 12;
  } ULP_TRIG_REG_bit;
} @ 0xFF4A02;

__no_init volatile union
{
  unsigned short ULP_PORT_REG;
  struct
  {
    unsigned short ULP_PORT_VAL                    : 1;
    unsigned short ULP_PORT_DIR                    : 2;
    unsigned short ULP_PORT_IE                     : 1;
    unsigned short ULP_PORT_TRIG                   : 2;
    unsigned short ULP_PORT_WEN                    : 1;
    unsigned short ULP_PORT_MODE                   : 1;
  } ULP_PORT_REG_bit;
} @ 0xFF4A04;

__no_init volatile union
{
  unsigned short ULP_PHASE_REG;
  struct
  {
    unsigned short ULP_PHASE                       : 9;
    unsigned short                                 : 6;
    unsigned short ULP_PH_BUSY                     : 1;
  } ULP_PHASE_REG_bit;
} @ 0xFF4A06;

__no_init volatile unsigned short ULP_TIMERL_REG @ 0xFF4A08;

__no_init volatile unsigned short ULP_TIMERH_REG @ 0xFF4A0A;

__no_init volatile unsigned short ULP_WAKEUPL_REG @ 0xFF4A0C;

__no_init volatile unsigned short ULP_WAKEUPH_REG @ 0xFF4A0E;

__no_init volatile union
{
  unsigned short ULP_STATUS_REG;
  struct
  {
    unsigned short ULP_TIMER_STS                   : 1;
    unsigned short ULP_PORT_STS                    : 1;
    unsigned short ULP_TIMER_STSR                  : 1;
    unsigned short ULP_PORT_STSR                   : 1;
    unsigned short ULP_XTAL_VAL                    : 1;
    unsigned short ULP_XTAL_OK                     : 1;
    unsigned short ULP_OSC_VAL                     : 1;
    unsigned short ULP_WAKEUP_VAL                  : 1;
    unsigned short ULP_TRIG_VAL                    : 1;
  } ULP_STATUS_REG_bit;
} @ 0xFF4A10;

__no_init volatile unsigned short ULP_TEST_REG @ 0xFF4A12;

__no_init volatile unsigned short WATCHDOG_REG @ 0xFF4C00;

__no_init volatile union
{
  unsigned short SET_FREEZE_REG;
  struct
  {
    unsigned short FRZ_DIP                         : 1;
    unsigned short FRZ_TIM0                        : 1;
    unsigned short FRZ_TIM1                        : 1;
    unsigned short FRZ_WDOG                        : 1;
    unsigned short FRZ_DMA0                        : 1;
    unsigned short FRZ_DMA1                        : 1;
    unsigned short FRZ_DMA2                        : 1;
    unsigned short FRZ_DMA3                        : 1;
  } SET_FREEZE_REG_bit;
} @ 0xFF5000;

__no_init volatile union
{
  unsigned short RESET_FREEZE_REG;
  struct
  {
    unsigned short FRZ_DIP                         : 1;
    unsigned short FRZ_TIM0                        : 1;
    unsigned short FRZ_TIM1                        : 1;
    unsigned short FRZ_WDOG                        : 1;
    unsigned short FRZ_DMA0                        : 1;
    unsigned short FRZ_DMA1                        : 1;
    unsigned short FRZ_DMA2                        : 1;
    unsigned short FRZ_DMA3                        : 1;
  } RESET_FREEZE_REG_bit;
} @ 0xFF5002;

__no_init volatile union
{
  unsigned short DEBUG_REG;
  struct
  {
    unsigned short CLK100_EDGE                     : 1;
    unsigned short CLK100_NEG                      : 1;
    unsigned short CLK100_POS                      : 1;
    unsigned short CLK100_SRC                      : 1;
    unsigned short ENV_B01                         : 1;
    unsigned short                                 : 2;
    unsigned short SW_RESET                        : 1;
    unsigned short                                 : 3;
    unsigned short CR16_DBGM                       : 1;
    unsigned short ALIAS_DIPRAM                    : 1;
    unsigned short OWI_SEL_SYNC                    : 1;
  } DEBUG_REG_bit;
} @ 0xFF5004;

__no_init volatile union
{
  unsigned short CACHE_CTRL_REG;
  struct
  {
    unsigned short CACHE_SIZE                      : 3;
    unsigned short                                 : 1;
    unsigned short CACHE_MODE                      : 2;
    unsigned short CACHE_LOCK                      : 1;
    unsigned short                                 : 1;
    unsigned short ICACHE_B_SIZE                   : 1;
    unsigned short                                 : 1;
    unsigned short DCACHE_B_SIZE                   : 1;
  } CACHE_CTRL_REG_bit;
} @ 0xFF5010;

__no_init volatile union
{
  unsigned short CACHE_LEN0_REG;
  struct
  {
    unsigned short CACHE_LEN0                      : 9;
  } CACHE_LEN0_REG_bit;
} @ 0xFF5012;

__no_init volatile union
{
  unsigned short CACHE_START0_REG;
  struct
  {
    unsigned short CACHE_START0                    : 9;
  } CACHE_START0_REG_bit;
} @ 0xFF5014;

__no_init volatile union
{
  unsigned short CACHE_LEN1_REG;
  struct
  {
    unsigned short CACHE_LEN1                      : 9;
  } CACHE_LEN1_REG_bit;
} @ 0xFF5016;

__no_init volatile union
{
  unsigned short CACHE_START1_REG;
  struct
  {
    unsigned short CACHE_START1                    : 9;
  } CACHE_START1_REG_bit;
} @ 0xFF5018;

__no_init volatile union
{
  unsigned short CACHE_STATUS_REG;
  struct
  {
    unsigned short                                 : 10;
    unsigned short ICACHE_HIT                      : 1;
    unsigned short DCACHE_HIT                      : 1;
    unsigned short CACHE_TOUCH_TOGGLE              : 1;
    unsigned short CACHE_TOUCH                     : 1;
  } CACHE_STATUS_REG_bit;
} @ 0xFF501A;

__no_init volatile unsigned short CACHE_TEST_REG @ 0xFF501C;

__no_init volatile union
{
  unsigned short TRACE_CTRL_REG;
  struct
  {
    unsigned short TRACE_SIZE                      : 3;
    unsigned short TRACE_COND                      : 1;
    unsigned short EXT_EVENTS_ON                   : 1;
    unsigned short DIP_EVENTS_ON                   : 1;
    unsigned short DSP_EVENTS_ON                   : 1;
    unsigned short BUS_EVENTS_ON                   : 1;
    unsigned short D_TRACE_EV_ON                   : 1;
    unsigned short I_TRACE_EV_ON                   : 1;
    unsigned short D_TRACE_ON                      : 1;
    unsigned short I_TRACE_ON                      : 1;
    unsigned short TRACE_COND_EXT                  : 3;
    unsigned short TRACE_MODE                      : 1;
  } TRACE_CTRL_REG_bit;
} @ 0xFF5020;

__no_init volatile union
{
  unsigned short TRACE_STATUS_REG;
  struct
  {
    unsigned short TRACE_IDX                       : 11;
    unsigned short                                 : 2;
    unsigned short TRACE_TOUCH_TOGGLE              : 1;
    unsigned short TRACE_EOB                       : 1;
    unsigned short TRACE_BUSY                      : 1;
  } TRACE_STATUS_REG_bit;
} @ 0xFF5022;

__no_init volatile union
{
  unsigned short TRACE_START0_REG;
  struct
  {
    unsigned short TRACE_START0                    : 15;
  } TRACE_START0_REG_bit;
} @ 0xFF5024;

__no_init volatile union
{
  unsigned short TRACE_LEN0_REG;
  struct
  {
    unsigned short TRACE_LEN0                      : 15;
  } TRACE_LEN0_REG_bit;
} @ 0xFF5026;

__no_init volatile union
{
  unsigned short TRACE_START1_REG;
  struct
  {
    unsigned short TRACE_START1                    : 15;
  } TRACE_START1_REG_bit;
} @ 0xFF5028;

__no_init volatile union
{
  unsigned short TRACE_LEN1_REG;
  struct
  {
    unsigned short TRACE_LEN1                      : 15;
  } TRACE_LEN1_REG_bit;
} @ 0xFF502A;

__no_init volatile unsigned short TRACE_TIMERL_REG @ 0xFF502C;

__no_init volatile unsigned short TRACE_TIMERH_REG @ 0xFF502E;

__no_init volatile union
{
  unsigned short SET_INT_PENDING_REG;
  struct
  {
    unsigned short ACCESS_INT_PEND                 : 1;
    unsigned short KEYB_INT_PEND                   : 1;
    unsigned short UART2_RI_TI_INT_PEND            : 1;
    unsigned short CT_CLASSD_INT_PEND              : 1;
    unsigned short UART_RI_INT_PEND                : 1;
    unsigned short UART_TI_INT_PEND                : 1;
    unsigned short SPI_INT_PEND                    : 1;
    unsigned short TIM0_INT_PEND                   : 1;
    unsigned short TIM1_INT_PEND                   : 1;
    unsigned short CLK100_INT_PEND                 : 1;
    unsigned short DIP_INT_PEND                    : 1;
    unsigned short AD_INT_PEND                     : 1;
    unsigned short SPI2_INT_PEND                   : 1;
    unsigned short DSP_INT_PEND                    : 1;
    unsigned short ULP_INT_PEND                    : 1;
  } SET_INT_PENDING_REG_bit;
} @ 0xFF5400;

__no_init volatile union
{
  unsigned short RESET_INT_PENDING_REG;
  struct
  {
    unsigned short ACCESS_INT_PEND                 : 1;
    unsigned short KEYB_INT_PEND                   : 1;
    unsigned short UART2_RI_TI_INT_PEND            : 1;
    unsigned short CT_CLASSD_INT_PEND              : 1;
    unsigned short UART_RI_INT_PEND                : 1;
    unsigned short UART_TI_INT_PEND                : 1;
    unsigned short SPI_INT_PEND                    : 1;
    unsigned short TIM0_INT_PEND                   : 1;
    unsigned short TIM1_INT_PEND                   : 1;
    unsigned short CLK100_INT_PEND                 : 1;
    unsigned short DIP_INT_PEND                    : 1;
    unsigned short AD_INT_PEND                     : 1;
    unsigned short SPI2_INT_PEND                   : 1;
    unsigned short DSP_INT_PEND                    : 1;
    unsigned short ULP_INT_PEND                    : 1;
  } RESET_INT_PENDING_REG_bit;
} @ 0xFF5402;

__no_init volatile union
{
  unsigned short INT0_PRIORITY_REG;
  struct
  {
    unsigned short SPI2_INT_PRIO                   : 3;
    unsigned short                                 : 1;
    unsigned short DSP_INT_PRIO                    : 3;
    unsigned short                                 : 1;
    unsigned short ULP_INT_PRIO                    : 3;
  } INT0_PRIORITY_REG_bit;
} @ 0xFF5404;

__no_init volatile union
{
  unsigned short INT1_PRIORITY_REG;
  struct
  {
    unsigned short TIM1_INT_PRIO                   : 3;
    unsigned short                                 : 1;
    unsigned short CLK100_INT_PRIO                 : 3;
    unsigned short                                 : 1;
    unsigned short DIP_INT_PRIO                    : 3;
    unsigned short                                 : 1;
    unsigned short AD_INT_PRIO                     : 3;
  } INT1_PRIORITY_REG_bit;
} @ 0xFF5406;

__no_init volatile union
{
  unsigned short INT2_PRIORITY_REG;
  struct
  {
    unsigned short UART_RI_INT_PRIO                : 3;
    unsigned short                                 : 1;
    unsigned short UART_TI_INT_PRIO                : 3;
    unsigned short                                 : 1;
    unsigned short SPI_INT_PRIO                    : 3;
    unsigned short                                 : 1;
    unsigned short TIM0_INT_PRIO                   : 3;
  } INT2_PRIORITY_REG_bit;
} @ 0xFF5408;

__no_init volatile union
{
  unsigned short INT3_PRIORITY_REG;
  struct
  {
    unsigned short ACCESS_INT_PRIO                 : 3;
    unsigned short                                 : 1;
    unsigned short KEYB_INT_PRIO                   : 3;
    unsigned short                                 : 1;
    unsigned short UART2_RI_TI_INT_PRIO            : 3;
    unsigned short                                 : 1;
    unsigned short CT_CLASSD_INT_PRIO              : 3;
  } INT3_PRIORITY_REG_bit;
} @ 0xFF540A;

__no_init volatile union
{
  unsigned short PC_START_REG;
  struct
  {
    unsigned short PC_START10                      : 2;
    unsigned short PC_START                        : 14;
  } PC_START_REG_bit;
} @ 0xFF540C;

__no_init volatile union
{
  unsigned short CODEC_MIC_REG;
  struct
  {
    unsigned short MIC_MODE                        : 2;
    unsigned short MIC_PD                          : 1;
    unsigned short MIC_MUTE                        : 1;
    unsigned short MIC_GAIN                        : 4;
    unsigned short MIC_OFFCOM_SG                   : 1;
    unsigned short MIC_OFFCOM_ON                   : 1;
    unsigned short DSP_CTRL                        : 1;
    unsigned short MICH_ON                         : 1;
    unsigned short MIC_CADJ                        : 2;
    unsigned short MICHP_ON                        : 1;
    unsigned short MIC_LSR_ON                      : 1;
  } CODEC_MIC_REG_bit;
} @ 0xFF5800;

__no_init volatile union
{
  unsigned short CODEC_LSR_REG;
  struct
  {
    unsigned short LSRP_MODE                       : 2;
    unsigned short LSRP_PD                         : 1;
    unsigned short LSRN_MODE                       : 2;
    unsigned short LSRN_PD                         : 1;
    unsigned short LSRATT                          : 3;
    unsigned short LSREN_SE                        : 1;
  } CODEC_LSR_REG_bit;
} @ 0xFF5802;

__no_init volatile union
{
  unsigned short CODEC_VREF_REG;
  struct
  {
    unsigned short VREF_PD                         : 1;
    unsigned short VREF_FILT_PD                    : 1;
    unsigned short VREF_FILT_CADJ                  : 2;
    unsigned short VREF_INIT                       : 1;
    unsigned short AMP1V5_PD                       : 1;
    unsigned short VREF_BG_PD                      : 1;
    unsigned short BIAS_PD                         : 1;
    unsigned short AGND_LSR_PD                     : 1;
    unsigned short REFINT_PD                       : 1;
  } CODEC_VREF_REG_bit;
} @ 0xFF5804;

__no_init volatile union
{
  unsigned short CODEC_TONE_REG;
  struct
  {
    unsigned short CID_PD                          : 1;
    unsigned short CID_PR_DIS                      : 1;
    unsigned short RNG_PD                          : 1;
    unsigned short RNG_PR_DIS                      : 1;
    unsigned short PARA_PD                         : 1;
    unsigned short PARA_PR_DIS                     : 1;
    unsigned short RNG_CMP_PD                      : 1;
  } CODEC_TONE_REG_bit;
} @ 0xFF5806;

__no_init volatile union
{
  unsigned short CODEC_ADDA_REG;
  struct
  {
    unsigned short DA_PD                           : 1;
    unsigned short AD_PD                           : 1;
    unsigned short DA_CADJ                         : 2;
    unsigned short AD_CADJ                         : 2;
    unsigned short DA_DITH_OFF                     : 1;
    unsigned short AD_DITH_OFF                     : 1;
    unsigned short DA_HBW                          : 1;
    unsigned short LPF_PD                          : 1;
    unsigned short LPF_BW                          : 3;
    unsigned short ADC_VREF_LSR                    : 2;
    unsigned short AUTO_SYNC                       : 1;
  } CODEC_ADDA_REG_bit;
} @ 0xFF5808;

__no_init volatile unsigned short CODEC_OFFSET1_REG @ 0xFF580A;

__no_init volatile unsigned short CODEC_TEST_CTRL_REG @ 0xFF580C;

__no_init volatile unsigned short CODEC_OFFSET2_REG @ 0xFF580E;

__no_init volatile union
{
  unsigned short CODEC_MIC2_REG;
  struct
  {
    unsigned short MIC2_PD                         : 1;
    unsigned short MIC2_MUTE                       : 1;
    unsigned short MIC2_OFFCOM_SG                  : 1;
    unsigned short MIC2_OFFCOM_ON                  : 1;
    unsigned short MIC2_GAIN                       : 4;
    unsigned short MIC2_PMUX                       : 3;
    unsigned short MIC2_NMUX                       : 3;
    unsigned short MIC2_CADJ                       : 2;
  } CODEC_MIC2_REG_bit;
} @ 0xFF5810;

__no_init volatile unsigned short CODEC_MIC2_OFFSET1_REG @ 0xFF5812;

__no_init volatile unsigned short CODEC_MIC2_OFFSET2_REG @ 0xFF5814;

__no_init volatile union
{
  unsigned short CODEC_MIC_AUTO_REG;
  struct
  {
    unsigned short MIC_CONFIG                      : 3;
  } CODEC_MIC_AUTO_REG_bit;
} @ 0xFF5816;

__no_init volatile union
{
  unsigned short CODEC_LSR_AUTO_REG;
  struct
  {
    unsigned short LSR_CONFIG                      : 3;
  } CODEC_LSR_AUTO_REG_bit;
} @ 0xFF5818;

__no_init volatile union
{
  unsigned short CLASSD_CTRL_REG;
  struct
  {
    unsigned short CLASSD_PD                       : 1;
    unsigned short CLASSD_PROT                     : 1;
    unsigned short CLASSD_VOUT                     : 2;
    unsigned short CLASSD_CLIP                     : 3;
    unsigned short CLASSD_INT_BIT                  : 1;
    unsigned short CLASSD_DITH_D                   : 2;
    unsigned short CLASSD_DITH_A                   : 2;
    unsigned short CLASSD_MODE                     : 1;
    unsigned short CLASSD_MINT                     : 1;
    unsigned short CLASSD_MOPEN                    : 1;
    unsigned short CLASSD_POPEN                    : 1;
  } CLASSD_CTRL_REG_bit;
} @ 0xFF5C00;

__no_init volatile unsigned short CLASSD_CLEAR_INT_REG @ 0xFF5C02;

__no_init volatile union
{
  unsigned short CLASSD_BUZZER_REG;
  struct
  {
    unsigned short CLASSD_BUZ_GAIN                 : 4;
    unsigned short CLASSD_BUZ_MODE                 : 1;
  } CLASSD_BUZZER_REG_bit;
} @ 0xFF5C04;

__no_init volatile union
{
  unsigned short CLASSD_TEST_REG;
  struct
  {
    unsigned short CLASSD_SWITCH                   : 1;
    unsigned short CLASSD_RST_D                    : 1;
    unsigned short CLASSD_RST_A                    : 1;
    unsigned short CLASSD_FORCE                    : 1;
    unsigned short CLASSD_ANA_TEST                 : 3;
  } CLASSD_TEST_REG_bit;
} @ 0xFF5C06;

__no_init volatile union
{
  unsigned short CLASSD_NR_REG;
  struct
  {
    unsigned short CLASSD_NR_ACTIVE                : 1;
    unsigned short CLASSD_NR_LVL                   : 3;
    unsigned short CLASSD_NR_TON                   : 4;
    unsigned short CLASSD_NR_HYST                  : 2;
    unsigned short CLASSD_NR_ZERO                  : 2;
    unsigned short CLASSD_NR_MODE                  : 1;
  } CLASSD_NR_REG_bit;
} @ 0xFF5C08;

__no_init volatile union
{
  unsigned short CLASSD_MIC2_REG;
  struct
  {
    unsigned short MIC2_AD_ON                      : 1;
    unsigned short MIC2_PAOUT                      : 1;
    unsigned short MIC2_PAOUT_GAIN                 : 1;
    unsigned short MIC2_PAOUT_PSRR                 : 1;
    unsigned short PAOUT_INPUT                     : 1;
  } CLASSD_MIC2_REG_bit;
} @ 0xFF5C0A;

__no_init volatile union
{
  unsigned short DIP_STACK_REG;
  struct
  {
    unsigned short STACK_REG                       : 8;
    unsigned short STACK_BANK                      : 2;
  } DIP_STACK_REG_bit;
} @ 0xFF6000;

__no_init volatile union
{
  unsigned short DIP_PC_REG;
  struct
  {
    unsigned short DIP_PC                          : 8;
    unsigned short DIP_BANK                        : 2;
  } DIP_PC_REG_bit;
} @ 0xFF6002;

__no_init volatile union
{
  unsigned short DIP_STATUS_REG;
  struct
  {
    unsigned short DIP_INT_VEC                     : 4;
    unsigned short PD1_INT                         : 1;
    unsigned short DIP_BRK_INT                     : 1;
    unsigned short PRESCALER                       : 1;
    unsigned short URST                            : 1;
  } DIP_STATUS_REG_bit;
} @ 0xFF6004;

__no_init volatile union
{
  unsigned short DIP_CTRL_REG;
  struct
  {
    unsigned short DIP_INT_VEC                     : 4;
    unsigned short PD1_INT                         : 1;
    unsigned short DIP_BRK_INT                     : 1;
    unsigned short PRESCALER                       : 1;
    unsigned short URST                            : 1;
  } DIP_CTRL_REG_bit;
} @ 0xFF6006;

__no_init volatile union
{
  unsigned short DIP_STATUS1_REG;
  struct
  {
    unsigned short DIP_VNMI_VEC                    : 4;
  } DIP_STATUS1_REG_bit;
} @ 0xFF6008;

__no_init volatile union
{
  unsigned short DIP_CTRL1_REG;
  struct
  {
    unsigned short DIP_VNMI_VEC                    : 4;
  } DIP_CTRL1_REG_bit;
} @ 0xFF600A;

__no_init volatile union
{
  unsigned short DIP_SLOT_NUMBER_REG;
  struct
  {
    unsigned short SLOT_CNTER                      : 5;
  } DIP_SLOT_NUMBER_REG_bit;
} @ 0xFF600C;

__no_init volatile union
{
  unsigned short DIP_CTRL2_REG;
  struct
  {
    unsigned short DBUF                            : 1;
    unsigned short PRE_ACT                         : 1;
    unsigned short BRK_PRE_OVR                     : 1;
    unsigned short                                 : 1;
    unsigned short PD1_INT                         : 1;
    unsigned short DIP_BRK                         : 1;
    unsigned short                                 : 1;
    unsigned short EN_8DIV9                        : 1;
    unsigned short SLOTCNT_RES                     : 1;
    unsigned short FR_BMC                          : 1;
    unsigned short MFR_DSC                         : 1;
    unsigned short ZERO_DSC                        : 1;
  } DIP_CTRL2_REG_bit;
} @ 0xFF600E;

__no_init volatile union
{
  unsigned short DIP_MOD_SEL_REG;
  struct
  {
    unsigned short ARMOD0                          : 1;
    unsigned short ARMOD1                          : 1;
    unsigned short ARMOD2                          : 1;
    unsigned short ARMOD3                          : 1;
    unsigned short AWMOD0                          : 1;
    unsigned short AWMOD1                          : 1;
    unsigned short AWMOD2                          : 1;
    unsigned short AWMOD3                          : 1;
  } DIP_MOD_SEL_REG_bit;
} @ 0xFF6012;

__no_init volatile unsigned short DIP_MOD_VAL_REG @ 0xFF6014;

__no_init volatile union
{
  unsigned short DIP_DC01_REG;
  struct
  {
    unsigned short FRAME                           : 4;
    unsigned short MFRAME_LOW                      : 12;
  } DIP_DC01_REG_bit;
} @ 0xFF6016;

__no_init volatile union
{
  unsigned short DIP_DC23_REG;
  struct
  {
    unsigned short MFRAME_HIGH                     : 12;
  } DIP_DC23_REG_bit;
} @ 0xFF6018;

__no_init volatile unsigned short DIP_DC34_REG @ 0xFF601A;

__no_init volatile union
{
  unsigned short BMC_CTRL_REG;
  struct
  {
    unsigned short                                 : 8;
    unsigned short SIO_PD                          : 1;
    unsigned short                                 : 4;
    unsigned short BCNT_INH                        : 1;
  } BMC_CTRL_REG_bit;
} @ 0xFF6400;

__no_init volatile union
{
  unsigned short BMC_CTRL2_REG;
  struct
  {
    unsigned short                                 : 3;
    unsigned short RCV_CTL                         : 5;
    unsigned short RCK_SEL                         : 1;
    unsigned short BF_CNT_HLD                      : 1;
  } BMC_CTRL2_REG_bit;
} @ 0xFF6402;

__no_init volatile unsigned short BMC_TX_SFIELDL_REG @ 0xFF6404;

__no_init volatile unsigned short BMC_TX_SFIELDH_REG @ 0xFF6406;

__no_init volatile unsigned short BMC_RX_SFIELDL_REG @ 0xFF6408;

__no_init volatile unsigned short BMC_RX_SFIELDH_REG @ 0xFF640A;

__no_init volatile union
{
  unsigned short RF_BURST_MODE_CTRL_REG;
  struct
  {
    unsigned short CN                              : 7;
    unsigned short RFCAL                           : 6;
    unsigned short RSSI_MODE                       : 1;
    unsigned short FAD                             : 2;
    unsigned short RX_TX                           : 2;
  } RF_BURST_MODE_CTRL_REG_bit;
} @ 0xFF7000;

__no_init volatile union
{
  unsigned short RF_ALW_EN_REG;
  struct
  {
    unsigned short PA_FINAL_STAGE_ALW_EN           : 1;
    unsigned short PA_DRIVER_STAGE_ALW_EN          : 1;
    unsigned short PORT2_ALW_EN                    : 1;
    unsigned short PORT1_ALW_EN                    : 1;
    unsigned short PLLCLOSED_ALW_EN                : 1;
    unsigned short SYNTH_ALW_EN                    : 1;
    unsigned short BIAS_ALW_EN                     : 1;
    unsigned short RSSIPH_ALW_EN                   : 1;
    unsigned short DEM_ALW_EN                      : 1;
    unsigned short ADC_ALW_EN                      : 1;
    unsigned short IF_ALW_EN                       : 1;
    unsigned short LNAMIX_ALW_EN                   : 1;
    unsigned short PA_ALW_EN                       : 1;
  } RF_ALW_EN_REG_bit;
} @ 0xFF7008;

__no_init volatile unsigned short RF_PORT_RSSI_SI_REG @ 0xFF700A;

__no_init volatile unsigned short RF_TX_SI_REG @ 0xFF700C;

__no_init volatile unsigned short RF_RX_SI_REG @ 0xFF700E;

__no_init volatile union
{
  unsigned short RF_PORT1_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short EN_BY_TX                        : 1;
    unsigned short EN_BY_RX                        : 1;
    unsigned short SSI                             : 1;
  } RF_PORT1_DCF_REG_bit;
} @ 0xFF7010;

__no_init volatile union
{
  unsigned short RF_PORT2_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short EN_BY_TX                        : 1;
    unsigned short EN_BY_RX                        : 1;
    unsigned short SSI                             : 1;
  } RF_PORT2_DCF_REG_bit;
} @ 0xFF7012;

__no_init volatile union
{
  unsigned short RF_PA_DRIVER_STAGE_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short EN_BY_TX                        : 1;
    unsigned short EN_BY_RX                        : 1;
    unsigned short SSI                             : 1;
  } RF_PA_DRIVER_STAGE_DCF_REG_bit;
} @ 0xFF7014;

__no_init volatile union
{
  unsigned short RF_PA_FINAL_STAGE_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short EN_BY_TX                        : 1;
    unsigned short EN_BY_RX                        : 1;
    unsigned short SSI                             : 1;
  } RF_PA_FINAL_STAGE_DCF_REG_bit;
} @ 0xFF7016;

__no_init volatile union
{
  unsigned short RF_PLLCLOSED_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short DIS                             : 1;
    unsigned short                                 : 1;
    unsigned short SSI                             : 1;
  } RF_PLLCLOSED_DCF_REG_bit;
} @ 0xFF7018;

__no_init volatile union
{
  unsigned short RF_SYNTH_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short DIS                             : 1;
  } RF_SYNTH_DCF_REG_bit;
} @ 0xFF701A;

__no_init volatile union
{
  unsigned short RF_BIAS_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short DIS                             : 1;
  } RF_BIAS_DCF_REG_bit;
} @ 0xFF701C;

__no_init volatile union
{
  unsigned short RF_RSSIPH_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short DIS                             : 1;
  } RF_RSSIPH_DCF_REG_bit;
} @ 0xFF701E;

__no_init volatile union
{
  unsigned short RF_DEM_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short DIS                             : 1;
    unsigned short                                 : 1;
    unsigned short SSI                             : 1;
  } RF_DEM_DCF_REG_bit;
} @ 0xFF7020;

__no_init volatile union
{
  unsigned short RF_ADC_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short DIS                             : 1;
    unsigned short                                 : 1;
    unsigned short SSI                             : 1;
  } RF_ADC_DCF_REG_bit;
} @ 0xFF7022;

__no_init volatile union
{
  unsigned short RF_IF_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short DIS                             : 1;
    unsigned short                                 : 1;
    unsigned short SSI                             : 1;
  } RF_IF_DCF_REG_bit;
} @ 0xFF7024;

__no_init volatile union
{
  unsigned short RF_LNAMIX_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short DIS                             : 1;
    unsigned short                                 : 1;
    unsigned short SSI                             : 1;
  } RF_LNAMIX_DCF_REG_bit;
} @ 0xFF7026;

__no_init volatile union
{
  unsigned short RF_PA_DCF_REG;
  struct
  {
    unsigned short SET_OFFSET                      : 6;
    unsigned short RESET_OFFSET                    : 6;
    unsigned short DIS                             : 1;
    unsigned short RX_SENSITIVE                    : 1;
    unsigned short PADR_SSI                        : 2;
  } RF_PA_DCF_REG_bit;
} @ 0xFF7028;

__no_init volatile union
{
  unsigned short RF_FAD_WINDOW_DCF_REG;
  struct
  {
    unsigned short FAD_SWAP                        : 6;
    unsigned short FAD_DECIDE                      : 6;
  } RF_FAD_WINDOW_DCF_REG_bit;
} @ 0xFF702A;

__no_init volatile union
{
  unsigned short RF_RFCAL_CTRL_REG;
  struct
  {
    unsigned short RFCAL_STEPS                     : 3;
    unsigned short RFCAL_MODE                      : 2;
    unsigned short RFCAL_PERIOD                    : 2;
  } RF_RFCAL_CTRL_REG_bit;
} @ 0xFF7040;

__no_init volatile union
{
  unsigned short RF_DEM_CTRL_REG;
  struct
  {
    unsigned short DEM_INVERT                      : 1;
    unsigned short SLICE_EN                        : 1;
    unsigned short                                 : 5;
    unsigned short SLICE_EARLY                     : 1;
    unsigned short SLICE_VAL                       : 8;
  } RF_DEM_CTRL_REG_bit;
} @ 0xFF7044;

__no_init volatile union
{
  unsigned short RF_PREAMBLE_REG;
  struct
  {
    unsigned short PREAMBLE_DEL                    : 6;
    unsigned short AFC_VAL                         : 2;
    unsigned short AFC_EN                          : 1;
    unsigned short AFC_SETTLE_DEL                  : 2;
    unsigned short PREAMBLE_SYM                    : 2;
    unsigned short GATE_DATA                       : 1;
    unsigned short HALF_BIT_RATE                   : 1;
    unsigned short SYNC_RX_DATA                    : 1;
  } RF_PREAMBLE_REG_bit;
} @ 0xFF7046;

__no_init volatile union
{
  unsigned short RF_RSSI_REG;
  struct
  {
    unsigned short RFCAL_CAP                       : 6;
    unsigned short                                 : 2;
    unsigned short RSSI_VAL                        : 6;
    unsigned short FAD_CHOICE                      : 1;
  } RF_RSSI_REG_bit;
} @ 0xFF7048;

__no_init volatile union
{
  unsigned short RF_PORT_CTRL_REG;
  struct
  {
    unsigned short PORT1_INV                       : 1;
    unsigned short                                 : 3;
    unsigned short ANT_INACTIVE_VAL                : 1;
  } RF_PORT_CTRL_REG_bit;
} @ 0xFF704A;

__no_init volatile union
{
  unsigned short RF_PAD_IO_REG;
  struct
  {
    unsigned short P0_OE                           : 1;
    unsigned short P0N_OE                          : 1;
    unsigned short P1_OE                           : 1;
    unsigned short P2_OE                           : 1;
    unsigned short                                 : 2;
    unsigned short P0_IE                           : 1;
    unsigned short PAD_OE                          : 6;
  } RF_PAD_IO_REG_bit;
} @ 0xFF704C;

__no_init volatile union
{
  unsigned short RF_PLL_CTRL1_REG;
  struct
  {
    unsigned short CH_ZERO                         : 13;
    unsigned short SGN_NEG                         : 1;
    unsigned short CS_MO                           : 2;
  } RF_PLL_CTRL1_REG_bit;
} @ 0xFF7050;

__no_init volatile union
{
  unsigned short RF_PLL_CTRL2_REG;
  struct
  {
    unsigned short GAUSS_GAIN                      : 8;
    unsigned short MODINDEX                        : 6;
    unsigned short MODE20M                         : 1;
  } RF_PLL_CTRL2_REG_bit;
} @ 0xFF7052;

__no_init volatile union
{
  unsigned short RF_PLL_CTRL3_REG;
  struct
  {
    unsigned short FASTLOCK_PERIOD                 : 10;
    unsigned short FASTLOCK                        : 1;
    unsigned short LOCK_TIME                       : 2;
  } RF_PLL_CTRL3_REG_bit;
} @ 0xFF7054;

__no_init volatile union
{
  unsigned short RF_PLL_CTRL4_REG;
  struct
  {
    unsigned short MODCAL_PERIOD                   : 8;
    unsigned short MODCAL_TRIG                     : 1;
    unsigned short                                 : 2;
    unsigned short SD2_ORDER                       : 2;
    unsigned short KMOD_ALPHA                      : 3;
  } RF_PLL_CTRL4_REG_bit;
} @ 0xFF7056;

__no_init volatile union
{
  unsigned short RF_SLICER_REG;
  struct
  {
    unsigned short TRACK_SLICE                     : 1;
    unsigned short DECIDE_ON_AVG                   : 1;
    unsigned short SLICE_LOW                       : 6;
  } RF_SLICER_REG_bit;
} @ 0xFF7058;

__no_init volatile union
{
  unsigned short RF_SLICER_RESULT_REG;
  struct
  {
    unsigned short                                 : 6;
    unsigned short AFC_VAL                         : 2;
    unsigned short SLICE_VAL                       : 8;
  } RF_SLICER_RESULT_REG_bit;
} @ 0xFF705A;

__no_init volatile unsigned short RF_GAUSS_GAIN_RESULT_REG @ 0xFF705C;

__no_init volatile union
{
  unsigned short RF_BURST_MODE_SHADOW1_REG;
  struct
  {
    unsigned short CN_SHW                          : 8;
    unsigned short RFCAL_SHW                       : 6;
    unsigned short RSSI_MODE_SHW                   : 1;
  } RF_BURST_MODE_SHADOW1_REG_bit;
} @ 0xFF7070;

__no_init volatile union
{
  unsigned short RF_BURST_MODE_SHADOW2_REG;
  struct
  {
    unsigned short FAD_SHW                         : 2;
    unsigned short TX_ASSERT                       : 1;
    unsigned short RX_ASSERT                       : 1;
    unsigned short SHADOW_EN                       : 1;
  } RF_BURST_MODE_SHADOW2_REG_bit;
} @ 0xFF7072;

__no_init volatile union
{
  unsigned short RF_DCF_MONITOR_REG;
  struct
  {
    unsigned short DP0_SEL                         : 4;
    unsigned short DP1_SEL                         : 4;
    unsigned short DP2_SEL                         : 4;
    unsigned short DP3_SEL                         : 4;
  } RF_DCF_MONITOR_REG_bit;
} @ 0xFF7074;

__no_init volatile unsigned short RF_SYNTH_CTRL1_REG @ 0xFF7080;

__no_init volatile unsigned short RF_SYNTH_CTRL2_REG @ 0xFF7082;

__no_init volatile unsigned short RF_AGC_REG @ 0xFF7084;

__no_init volatile unsigned short RF_AGC12_TH_REG @ 0xFF7086;

__no_init volatile unsigned short RF_AGC12_ALPHA_REG @ 0xFF7088;

__no_init volatile unsigned short RF_POSITIONING_REG @ 0xFF708A;

__no_init volatile unsigned short RF_DC_OFFSET_REG @ 0xFF708C;

__no_init volatile unsigned short RF_DC_OFFSET34_REG @ 0xFF708E;

__no_init volatile unsigned short RF_IQ_DC_OFFSET_REG @ 0xFF7090;

__no_init volatile unsigned short RF_IF_CTRL_REG @ 0xFF7092;

__no_init volatile unsigned short RF_REF_OSC_REG @ 0xFF7094;

__no_init volatile unsigned short RF_ADC_CTRL_REG @ 0xFF7096;

__no_init volatile unsigned short RF_RFIO_CTRL_REG @ 0xFF7098;

__no_init volatile unsigned short RF_BIAS_CTRL_REG @ 0xFF709A;

__no_init volatile unsigned short RF_DRIFT_TEST_REG @ 0xFF709C;

__no_init volatile unsigned short RF_TEST_MODE_REG @ 0xFF709E;

__no_init volatile unsigned short RF_LDO_TEST_REG @ 0xFF70A0;

__no_init volatile unsigned short RF_PLL_CTRL5_REG @ 0xFF70AC;

__no_init volatile unsigned short RF_PLL_CTRL6_REG @ 0xFF70AE;

__no_init volatile union
{
  unsigned short RF_BBADC_CTRL_REG;
  struct
  {
    unsigned short RF_BBADC_TEST1                  : 3;
    unsigned short PA_CASCODE_LEVEL                : 3;
    unsigned short RF_BBADC_TEST0                  : 10;
  } RF_BBADC_CTRL_REG_bit;
} @ 0xFF70B0;

__no_init volatile union
{
  unsigned short RF_PA_CTRL1_REG;
  struct
  {
    unsigned short                                 : 4;
    unsigned short PA_CUR_SET1                     : 4;
    unsigned short PA_CUR_SET2                     : 4;
    unsigned short PA_ATT_SET                      : 4;
  } RF_PA_CTRL1_REG_bit;
} @ 0xFF70B2;

__no_init volatile union
{
  unsigned short RF_PA_CTRL2_REG;
  struct
  {
    unsigned short                                 : 8;
    unsigned short RAMP_SPEED1                     : 4;
    unsigned short RAMP_SPEED2                     : 4;
  } RF_PA_CTRL2_REG_bit;
} @ 0xFF70B4;

__no_init volatile unsigned short RF_IFCAL_RESULT_REG @ 0xFF70B6;

__no_init volatile unsigned short RF_DC_OFFSET12_REG @ 0xFF70B8;

__no_init volatile unsigned short RF_AGC_RESULT_REG @ 0xFF70BA;

__no_init volatile unsigned short RF_GAUSS_GAIN_MSB_REG @ 0xFF70BC;

__no_init volatile unsigned short RF_RXFE_CTRL_REG @ 0xFF70BE;

__no_init volatile union
{
  unsigned short RF_FAFC_CTRL_REG;
  struct
  {
    unsigned short FAFC_EN                         : 1;
    unsigned short FAFC_MEAN                       : 1;
    unsigned short FAST_AFC_EN                     : 1;
    unsigned short FAST_VAL                        : 8;
  } RF_FAFC_CTRL_REG_bit;
} @ 0xFF70C0;

__no_init volatile unsigned short RF_FAFC_RESULT_REG @ 0xFF70C2;

__no_init volatile union
{
  unsigned short RF_TEST_MODE2_REG;
  struct
  {
    unsigned short PA_CUR_SET3                     : 6;
    unsigned short PA_ICTRL_ENABLE                 : 1;
    unsigned short RF_TEST_MODE0                   : 9;
  } RF_TEST_MODE2_REG_bit;
} @ 0xFF70C4;

__no_init volatile unsigned short CHIP_TEST1_REG @ 0xFFFBF4;

__no_init volatile unsigned short CHIP_TEST2_REG @ 0xFFFBF4;

__no_init volatile unsigned short CHIP_ID1_REG @ 0xFFFBF8;

__no_init volatile unsigned short CHIP_ID2_REG @ 0xFFFBF8;

__no_init volatile unsigned short CHIP_ID3_REG @ 0xFFFBFA;

__no_init volatile unsigned short CHIP_SWC_REG @ 0xFFFBFA;

__no_init volatile unsigned short CHIP_REVISION_REG @ 0xFFFBFC;

__no_init volatile unsigned short CHIP_CONFIG1_REG @ 0xFFFBFC;

__no_init volatile unsigned short CHIP_CONFIG2_REG @ 0xFFFBFE;

__no_init volatile unsigned short CHIP_CONFIG3_REG @ 0xFFFBFE;

__no_init volatile unsigned short INT_ACK_CR16_START @ 0xFFFC00;

__no_init volatile unsigned short INT_ACK_CR16_END @ 0xFFFFFE;

__no_init volatile unsigned short DIP_RAM_START @ 0x1000000;

__no_init volatile unsigned short DIP_RAM_END @ 0x10001FE;

__no_init volatile unsigned short DIP_RAM_2_START @ 0x1000200;

__no_init volatile unsigned short DIP_RAM_2_END @ 0x10003FE;

__no_init volatile unsigned short DIP_RAM_3_START @ 0x1000400;

__no_init volatile unsigned short DIP_RAM_3_END @ 0x10004FE;

__no_init volatile union
{
  unsigned short DSP_MAIN_SYNC0_REG;
  struct
  {
    unsigned short RAMIN0_SYNC                     : 2;
    unsigned short RAMIN1_SYNC                     : 2;
    unsigned short RAMIN2_SYNC                     : 2;
    unsigned short RAMIN3_SYNC                     : 2;
    unsigned short RAMOUT0_SYNC                    : 2;
    unsigned short RAMOUT1_SYNC                    : 2;
    unsigned short RAMOUT2_SYNC                    : 2;
    unsigned short RAMOUT3_SYNC                    : 2;
  } DSP_MAIN_SYNC0_REG_bit;
} @ 0x1027F80;

__no_init volatile union
{
  unsigned short DSP_MAIN_SYNC1_REG;
  struct
  {
    unsigned short DSP_SYNC0                       : 2;
    unsigned short DSP_SYNC1                       : 2;
    unsigned short DSP_SYNC2                       : 2;
    unsigned short AD_SYNC                         : 2;
    unsigned short DA_CLASSD_SYNC                  : 2;
    unsigned short DA_LSR_SYNC                     : 2;
    unsigned short ADC_SYNC                        : 2;
    unsigned short PCM_SYNC                        : 2;
  } DSP_MAIN_SYNC1_REG_bit;
} @ 0x1027F82;

__no_init volatile unsigned short DSP_MAIN_CNT_REG @ 0x1027F84;

__no_init volatile unsigned short DSP_ADC1S_REG @ 0x1027F86;

__no_init volatile unsigned short DSP_ADC0S_REG @ 0x1027F88;

__no_init volatile unsigned short DSP_CLASSD_REG @ 0x1027F8A;

__no_init volatile union
{
  unsigned short DSP_CODEC_MIC_GAIN_REG;
  struct
  {
    unsigned short                                 : 12;
    unsigned short DSP_MIC_GAIN                    : 4;
  } DSP_CODEC_MIC_GAIN_REG_bit;
} @ 0x1027F8C;

__no_init volatile unsigned short DSP_CODEC_OUT_REG @ 0x1027F8E;

__no_init volatile unsigned short DSP_CODEC_IN_REG @ 0x1027F90;

__no_init volatile unsigned short DSP_RAM_OUT0_REG @ 0x1027F92;

__no_init volatile unsigned short DSP_RAM_OUT1_REG @ 0x1027F94;

__no_init volatile unsigned short DSP_RAM_OUT2_REG @ 0x1027F96;

__no_init volatile unsigned short DSP_RAM_OUT3_REG @ 0x1027F98;

__no_init volatile unsigned short DSP_RAM_IN0_REG @ 0x1027F9A;

__no_init volatile unsigned short DSP_RAM_IN1_REG @ 0x1027F9C;

__no_init volatile unsigned short DSP_RAM_IN2_REG @ 0x1027F9E;

__no_init volatile unsigned short DSP_RAM_IN3_REG @ 0x1027FA0;

__no_init volatile union
{
  unsigned short DSP_ZCROSS1_OUT_REG;
  struct
  {
    unsigned short                                 : 15;
    unsigned short DSP_ZCROSSx                     : 1;
  } DSP_ZCROSS1_OUT_REG_bit;
} @ 0x1027FA2;

__no_init volatile union
{
  unsigned short DSP_ZCROSS2_OUT_REG;
  struct
  {
    unsigned short                                 : 15;
    unsigned short DSP_ZCROSSx                     : 1;
  } DSP_ZCROSS2_OUT_REG_bit;
} @ 0x1027FA4;

__no_init volatile unsigned short DSP_PCM_OUT0_REG @ 0x1027FA6;

__no_init volatile unsigned short DSP_PCM_OUT1_REG @ 0x1027FA8;

__no_init volatile unsigned short DSP_PCM_OUT2_REG @ 0x1027FAA;

__no_init volatile unsigned short DSP_PCM_OUT3_REG @ 0x1027FAC;

__no_init volatile unsigned short DSP_PCM_IN0_REG @ 0x1027FAE;

__no_init volatile unsigned short DSP_PCM_IN1_REG @ 0x1027FB0;

__no_init volatile unsigned short DSP_PCM_IN2_REG @ 0x1027FB2;

__no_init volatile unsigned short DSP_PCM_IN3_REG @ 0x1027FB4;

__no_init volatile union
{
  unsigned short DSP_PCM_CTRL_REG;
  struct
  {
    unsigned short PCM_EN                          : 1;
    unsigned short PCM_MASTER                      : 1;
    unsigned short DSP_PCM_SYNC                    : 1;
    unsigned short PCM_FSC0LEN                     : 2;
    unsigned short PCM_FSC0DEL                     : 1;
    unsigned short PCM_PPOD                        : 1;
    unsigned short PCM_CLKINV                      : 1;
    unsigned short PCM_FSCINV                      : 1;
    unsigned short PCM_CLK_BIT                     : 1;
    unsigned short PCM_CH0_DEL                     : 5;
    unsigned short PCM_FSC0LEN48                   : 1;
  } DSP_PCM_CTRL_REG_bit;
} @ 0x1027FB6;

__no_init volatile unsigned short DSP_PHASE_INFO_REG @ 0x1027FB8;

__no_init volatile union
{
  unsigned short DSP_MAIN_CTRL_REG;
  struct
  {
    unsigned short DSP_MAIN_PRESET                 : 8;
    unsigned short DSP_MAIN_CTRL                   : 2;
    unsigned short PCM_DOMAIN                      : 1;
    unsigned short AD_DOMAIN                       : 1;
    unsigned short LSR_DOMAIN                      : 1;
    unsigned short CLASSD_DOMAIN                   : 1;
  } DSP_MAIN_CTRL_REG_bit;
} @ 0x1027FBC;

__no_init volatile union
{
  unsigned short DSP_CLASSD_BUZZOFF_REG;
  struct
  {
    unsigned short                                 : 15;
    unsigned short BUZZOFF                         : 1;
  } DSP_CLASSD_BUZZOFF_REG_bit;
} @ 0x1027FBE;

__no_init volatile unsigned short DSP_PCM_OUT4_REG @ 0x1027FC0;

__no_init volatile unsigned short DSP_PCM_OUT5_REG @ 0x1027FC2;

__no_init volatile unsigned short DSP_PCM_IN4_REG @ 0x1027FC4;

__no_init volatile unsigned short DSP_PCM_IN5_REG @ 0x1027FC6;

__no_init volatile unsigned short DSP_CODEC2_IN_REG @ 0x1027FC8;

__no_init volatile union
{
  unsigned short DSP_CTRL_REG;
  struct
  {
    unsigned short DIP_DSP_VEC                     : 2;
    unsigned short DSP_EN                          : 1;
    unsigned short DSP_CLK_EN                      : 1;
    unsigned short DSP_CR16_INT                    : 1;
    unsigned short DSP_PATCH                       : 1;
    unsigned short                                 : 2;
    unsigned short DBG_EN                          : 1;
  } DSP_CTRL_REG_bit;
} @ 0x1027FD0;

__no_init volatile unsigned short DSP_PC_REG @ 0x1027FD2;

__no_init volatile unsigned short DSP_PC_START_REG @ 0x1027FD4;

__no_init volatile union
{
  unsigned short DSP_IRQ_START_REG;
  struct
  {
    unsigned short                                 : 4;
    unsigned short DSP_IRQ_START                   : 12;
  } DSP_IRQ_START_REG_bit;
} @ 0x1027FD6;

__no_init volatile unsigned short DSP_INT_REG @ 0x1027FD8;

__no_init volatile unsigned short DSP_INT_MASK_REG @ 0x1027FDA;

__no_init volatile union
{
  unsigned short DSP_INT_PRIO1_REG;
  struct
  {
    unsigned short DSP_INT2_PRIO                   : 3;
    unsigned short                                 : 1;
    unsigned short DSP_INT1_PRIO                   : 3;
    unsigned short                                 : 1;
    unsigned short DSP_INT0_PRIO                   : 3;
  } DSP_INT_PRIO1_REG_bit;
} @ 0x1027FDC;

__no_init volatile union
{
  unsigned short DSP_INT_PRIO2_REG;
  struct
  {
    unsigned short DSP_INT5_PRIO                   : 3;
    unsigned short                                 : 1;
    unsigned short DSP_INT4_PRIO                   : 3;
    unsigned short                                 : 1;
    unsigned short DSP_INT3_PRIO                   : 3;
  } DSP_INT_PRIO2_REG_bit;
} @ 0x1027FDE;

__no_init volatile union
{
  unsigned short DSP_OVERFLOW_REG;
  struct
  {
    unsigned short INT_OVERFLOW                    : 6;
    unsigned short WTF_OVERFLOW                    : 1;
    unsigned short IRQ_OVERFLOW                    : 1;
    unsigned short M_INT_OVERFLOW                  : 6;
    unsigned short M_WTF_OVERFLOW                  : 1;
    unsigned short M_IRQ_OVERFLOW                  : 1;
  } DSP_OVERFLOW_REG_bit;
} @ 0x1027FE0;

__no_init volatile union
{
  unsigned short DSP_JTBL_REG;
  struct
  {
    unsigned short                                 : 9;
    unsigned short DSP_JTBL                        : 7;
  } DSP_JTBL_REG_bit;
} @ 0x1027FE2;

__no_init volatile union
{
  unsigned short DSP_AUX_REG;
  struct
  {
    unsigned short CR16_SHRA                       : 1;
  } DSP_AUX_REG_bit;
} @ 0x1027FE4;

__no_init volatile unsigned short DBG_IREG @ 0x1027FF0;

__no_init volatile unsigned short DBG_INOUT_REG_LSW @ 0x1027FF4;

__no_init volatile unsigned short DBG_INOUT_REG_MSW @ 0x1027FF6;

__no_init volatile unsigned short DSP_TIMERL_REG @ 0x1027FF8;

__no_init volatile unsigned short DSP_TIMERH_REG @ 0x1027FFA;

__no_init volatile union
{
  unsigned short DSP_TIMER_CTRL_REG;
  struct
  {
    unsigned short DSP_TIM_CTRL                    : 1;
    unsigned short DSP_TIM_STOP                    : 1;
    unsigned short DSP_TIM_MODE                    : 2;
    unsigned short DSP_TIM_MEM                     : 1;
    unsigned short DSP_TIM_BRIDGE                  : 1;
    unsigned short DSP_TIM_JMP                     : 1;
    unsigned short DSP_TIM_PATCH                   : 1;
  } DSP_TIMER_CTRL_REG_bit;
} @ 0x1027FFC;

__no_init volatile unsigned short DSP_MC_RAM_START @ 0x1030000;

__no_init volatile unsigned short DSP_MC_RAM_END @ 0x10307FE;

__no_init volatile unsigned short DSP_MC_SHARED_RAM_START @ 0x010000;

__no_init volatile unsigned short DSP_MC_SHARED_RAM_END @ 0x017FFE;

__no_init volatile unsigned short DSP_MC_ROM_START @ 0x1040000;

__no_init volatile unsigned short DSP_MC_ROM_END @ 0x104BFFE;

#undef __no_init

#pragma language=default
#endif  /* __IAR_SYSTEMS_ICC__  */

#ifdef __IAR_SYSTEMS_ASM__

/*-------------------------------------------------------------------------
 *   Port registers
 *-------------------------------------------------------------------------*/

RAM_START                                  DEFINE 0x000000

RAM_END                                    DEFINE 0x003FFF

RAM_ADM_START                              DEFINE 0x009000

RAM_ADM_END                                DEFINE 0x009FFF

SHARED_RAM_START                           DEFINE 0x010000

SHARED_RAM_END                             DEFINE 0x017FFF

PROGRAM_START                              DEFINE 0x020000

PROGRAM_END                                DEFINE 0xFEEFFF

BOOT_ROM_START                             DEFINE 0xFEF000

BOOT_FROM UART                             DEFINE 0xFEF002

BOOT_FROM_QSPI                             DEFINE 0xFEF004

BOOT_ROM_ID                                DEFINE 0xFEF7F8

BOOT_ROM_END                               DEFINE 0xFEF7FF

QSPIC_CTRLBUS_REG                          DEFINE 0xFF0C00
QSPIC_SET_SINGLE                           DEFINE 0
QSPIC_SET_DUAL                             DEFINE 1
QSPIC_SET_QUAD                             DEFINE 2
QSPIC_EN_CS                                DEFINE 3
QSPIC_DIS_CS                               DEFINE 4

QSPIC_CTRLMODE_REG                         DEFINE 0xFF0C04
QSPIC_AUTO_MD                              DEFINE 0
QSPIC_CLK_MD                               DEFINE 1
QSPIC_IO2_OEN                              DEFINE 2
QSPIC_IO3_OEN                              DEFINE 3
QSPIC_IO2_DAT                              DEFINE 4
QSPIC_IO3_DAT                              DEFINE 5
QSPIC_HRDY_MD                              DEFINE 6
QSPIC_RXD_NEG                              DEFINE 7
QSPIC_RPIPE_EN                             DEFINE 8
QSPIC_PCLK_MD                              DEFINE 9
QSPIC_FORCENSEQ_EN                         DEFINE 12

QSPIC_RECVDATA_REG                         DEFINE 0xFF0C08
QSPIC_RECVDATA                             DEFINE 0

QSPIC_BURSTCMDA_REG                        DEFINE 0xFF0C0C
QSPIC_INST                                 DEFINE 0
QSPIC_INST_WB                              DEFINE 8
QSPIC_EXT_BYTE                             DEFINE 16
QSPIC_INST_TX_MD                           DEFINE 24
QSPIC_ADR_TX_MD                            DEFINE 26
QSPIC_EXT_TX_MD                            DEFINE 28
QSPIC_DMY_TX_MD                            DEFINE 30

QSPIC_BURSTCMDB_REG                        DEFINE 0xFF0C10
QSPIC_DAT_RX_MD                            DEFINE 0
QSPIC_EXT_BYTE_EN                          DEFINE 2
QSPIC_EXT_HF_DS                            DEFINE 3
QSPIC_DMY_NUM                              DEFINE 4
QSPIC_INST_MD                              DEFINE 6
QSPIC_WRAP_MD                              DEFINE 7
QSPIC_WRAP_LEN                             DEFINE 8
QSPIC_WRAP_SIZE                            DEFINE 10
QSPIC_CS_HIGH_MIN                          DEFINE 12

QSPIC_STATUS_REG                           DEFINE 0xFF0C14
QSPIC_BUSY                                 DEFINE 0

QSPIC_WRITEDATA_REG                        DEFINE 0xFF0C18
QSPIC_WRITEDATA                            DEFINE 0

QSPIC_READDATA_REG                         DEFINE 0xFF0C1C
QSPIC_READDATA                             DEFINE 0

QSPIC_DUMMYDATA_REG                        DEFINE 0xFF0C20
QSPIC_DUMMYDATA                            DEFINE 0

QSPIC_ERASECTRL_REG                        DEFINE 0xFF0C24
QSPIC_ERS_ADDR                             DEFINE 12
QSPIC_ERASE_EN                             DEFINE 24
QSPIC_ERS_STATE                            DEFINE 25

QSPIC_ERASECMDA_REG                        DEFINE 0xFF0C28

QSPIC_ERASECMDB_REG                        DEFINE 0xFF0C2C
QSPIC_ERS_TX_MD                            DEFINE 0
QSPIC_WEN_TX_MD                            DEFINE 2
QSPIC_SUS_TX_MD                            DEFINE 4
QSPIC_RES_TX_MD                            DEFINE 6
QSPIC_EAD_TX_MD                            DEFINE 8
QSPIC_ERS_CS_HI                            DEFINE 10
QSPIC_ERSRES_HLD                           DEFINE 16
QSPIC_RESSUS_DLY                           DEFINE 24

QSPIC_BURSTBRK_REG                         DEFINE 0xFF0C30
QSPIC_BRK_WRD                              DEFINE 0
QSPIC_BRK_EN                               DEFINE 16
QSPIC_BRK_SZ                               DEFINE 17
QSPIC_BRK_TX_MD                            DEFINE 18

QSPIC_STATUSCMD_REG                        DEFINE 0xFF0C34
QSPIC_RSTAT_INST                           DEFINE 0
QSPIC_RSTAT_TX_MD                          DEFINE 8
QSPIC_RSTAT_RX_MD                          DEFINE 10
QSPIC_BUSY_POS                             DEFINE 12
QSPIC_BUSY_VAL                             DEFINE 15
QSPIC_RESSTS_DLY                           DEFINE 16
QSPIC_STSDLY_SEL                           DEFINE 22

QSPIC_CHCKERASE_REG                        DEFINE 0xFF0C38
QSPIC_CHCKERASE                            DEFINE 0

QSPIC_GP_REG                               DEFINE 0xFF0C3C
AHB_QSPIC_OFFSET                           DEFINE 0
QSPIC_MEM_OFFSET                           DEFINE 2
QSPI_PIN_CUR                               DEFINE 5
SWITCH_QSPI_SPI                            DEFINE 7
SWITCH_SPI1_SPI2                           DEFINE 8

CLK_AMBA_REG                               DEFINE 0xFF4000
HCLK_DIV                                   DEFINE 0
PCLK_DIV                                   DEFINE 3
SRAM1_EN                                   DEFINE 5
MCRAM1_EN                                  DEFINE 7
HCLK_PRE                                   DEFINE 9
HCLK_XTAL                                  DEFINE 13

CLK_CODEC_DIV_REG                          DEFINE 0xFF4002
CODEC_DIV                                  DEFINE 0
CODEC_CLK_SEL                              DEFINE 7

CLK_CODEC_REG                              DEFINE 0xFF4004
CLK_MAIN_SEL                               DEFINE 0
CLK_AD_SEL                                 DEFINE 2
CLK_DA_CLASSD_SEL                          DEFINE 4
CLK_DA_LSR_SEL                             DEFINE 6
CLK_PCM_SEL                                DEFINE 8
CLK_MAIN_EN                                DEFINE 10
CLK_AD_EN                                  DEFINE 11
CLK_DA_CLASSD_EN                           DEFINE 12
CLK_DA_LSR_EN                              DEFINE 13
CLK_PCM_EN                                 DEFINE 14

CLK_DSP_REG                                DEFINE 0xFF4006
CLK_DSP_DIV                                DEFINE 0
CLK_DSP_EN                                 DEFINE 3
CLK_DSP_TIMER_SEL                          DEFINE 8
CLK_DSP_TIMER_EN                           DEFINE 10

CLK_FREQ_TRIM_REG                          DEFINE 0xFF400A
FINE_ADJ                                   DEFINE 0
COARSE_ADJ                                 DEFINE 8

CLK_PER_DIV_REG                            DEFINE 0xFF400C
PER_DIV                                    DEFINE 0
PER_CLK_SEL                                DEFINE 7

CLK_PER10_DIV_REG                          DEFINE 0xFF400E
PER10_DIV                                  DEFINE 0
PER10_CLK_SEL                              DEFINE 3
PER20_DIV                                  DEFINE 5

CLK_PLL_CTRL_REG                           DEFINE 0xFF4010
TESTMODE_SEL                               DEFINE 0
CP_ON                                      DEFINE 1
PLL_OUT_DIV                                DEFINE 2
PLL_CLK_SEL                                DEFINE 3
VCO_ON                                     DEFINE 4
HF_SEL                                     DEFINE 6
PLL_DIP_DIV                                DEFINE 7
DYN_SW                                     DEFINE 11
DIV2_CLK_SEL                               DEFINE 12

CLK_PLL_DIV_REG                            DEFINE 0xFF4012
XD1                                        DEFINE 0
VD1                                        DEFINE 2

CLK_XTAL_CTRL_REG                          DEFINE 0xFF4018
OSC300KHZ                                  DEFINE 0
XTAL_DIV                                   DEFINE 1

CLK_AUX_REG                                DEFINE 0xFF401A
BXTAL_EN                                   DEFINE 3
OWI_DIV                                    DEFINE 5
OWI_SEL                                    DEFINE 7
XDIV                                       DEFINE 8
CP_CLK_SEL                                 DEFINE 10
CLASSD_FREQ                                DEFINE 11

CLK_PCM_DIV_REG                            DEFINE 0xFF401C
PCM_DIV                                    DEFINE 0
PCM_CLK_SEL                                DEFINE 7

CLK_ULP_CTRL_REG                           DEFINE 0xFF401E
XTAL_PD                                    DEFINE 0
MAIN_CLK_SEL                               DEFINE 1
CLK300K_DIV                                DEFINE 2

DMA0_A_STARTL_REG                          DEFINE 0xFF4400

DMA0_A_STARTH_REG                          DEFINE 0xFF4402
DMAx_A_STARTH                              DEFINE 0

DMA0_B_STARTL_REG                          DEFINE 0xFF4404

DMA0_B_STARTH_REG                          DEFINE 0xFF4406
DMAx_B_STARTH                              DEFINE 0

DMA0_INT_REG                               DEFINE 0xFF4408

DMA0_LEN_REG                               DEFINE 0xFF440A

DMA0_CTRL_REG                              DEFINE 0xFF440C
DMA_ON                                     DEFINE 0
BW                                         DEFINE 1
DINT_MODE                                  DEFINE 3
DREQ_MODE                                  DEFINE 4
BINC                                       DEFINE 5
AINC                                       DEFINE 6
CIRCULAR                                   DEFINE 7
DMA_PRIO                                   DEFINE 8
DMA_IDLE                                   DEFINE 10
DMA_INIT                                   DEFINE 11

DMA0_IDX_REG                               DEFINE 0xFF440E

DMA1_A_STARTL_REG                          DEFINE 0xFF4410

DMA1_A_STARTH_REG                          DEFINE 0xFF4412
DMAx_A_STARTH                              DEFINE 0

DMA1_B_STARTL_REG                          DEFINE 0xFF4414

DMA1_B_STARTH_REG                          DEFINE 0xFF4416
DMAx_B_STARTH                              DEFINE 0

DMA1_INT_REG                               DEFINE 0xFF4418

DMA1_LEN_REG                               DEFINE 0xFF441A

DMA1_CTRL_REG                              DEFINE 0xFF441C
DMA_ON                                     DEFINE 0
BW                                         DEFINE 1
DINT_MODE                                  DEFINE 3
DREQ_MODE                                  DEFINE 4
BINC                                       DEFINE 5
AINC                                       DEFINE 6
CIRCULAR                                   DEFINE 7
DMA_PRIO                                   DEFINE 8
DMA_IDLE                                   DEFINE 10
DMA_INIT                                   DEFINE 11

DMA1_IDX_REG                               DEFINE 0xFF441E

DMA2_A_STARTL_REG                          DEFINE 0xFF4420

DMA2_A_STARTH_REG                          DEFINE 0xFF4422
DMAx_A_STARTH                              DEFINE 0

DMA2_B_STARTL_REG                          DEFINE 0xFF4424

DMA2_B_STARTH_REG                          DEFINE 0xFF4426
DMAx_B_STARTH                              DEFINE 0

DMA2_INT_REG                               DEFINE 0xFF4428

DMA2_LEN_REG                               DEFINE 0xFF442A

DMA2_CTRL_REG                              DEFINE 0xFF442C
DMA_ON                                     DEFINE 0
BW                                         DEFINE 1
DINT_MODE                                  DEFINE 3
DREQ_MODE                                  DEFINE 4
BINC                                       DEFINE 5
AINC                                       DEFINE 6
CIRCULAR                                   DEFINE 7
DMA_PRIO                                   DEFINE 8
DMA_IDLE                                   DEFINE 10
DMA_INIT                                   DEFINE 11

DMA2_IDX_REG                               DEFINE 0xFF442E

DMA3_A_STARTL_REG                          DEFINE 0xFF4430

DMA3_A_STARTH_REG                          DEFINE 0xFF4432
DMAx_A_STARTH                              DEFINE 0

DMA3_B_STARTL_REG                          DEFINE 0xFF4434

DMA3_B_STARTH_REG                          DEFINE 0xFF4436
DMAx_B_STARTH                              DEFINE 0

DMA3_INT_REG                               DEFINE 0xFF4438

DMA3_LEN_REG                               DEFINE 0xFF443A

DMA3_CTRL_REG                              DEFINE 0xFF443C
DMA_ON                                     DEFINE 0
BW                                         DEFINE 1
DINT_MODE                                  DEFINE 3
DREQ_MODE                                  DEFINE 4
BINC                                       DEFINE 5
AINC                                       DEFINE 6
CIRCULAR                                   DEFINE 7
DMA_PRIO                                   DEFINE 8
DMA_IDLE                                   DEFINE 10
DMA_INIT                                   DEFINE 11

DMA3_IDX_REG                               DEFINE 0xFF443E

TEST_ENV_REG                               DEFINE 0xFF4800
BOOT                                       DEFINE 0
ENV_SDI_W                                  DEFINE 2
ENV_SDI                                    DEFINE 4
ENV_REG7_5                                 DEFINE 5

TEST_CTRL_REG                              DEFINE 0xFF4802

TEST_CTRL2_REG                             DEFINE 0xFF4804

TEST_CTRL3_REG                             DEFINE 0xFF4806

TEST_CTRL4_REG                             DEFINE 0xFF4808

BANDGAP_REG                                DEFINE 0xFF4810
BANDGAP_VI                                 DEFINE 0
BANDGAP_VIT                                DEFINE 4
BANDGAP_I                                  DEFINE 6

BAT_CTRL_REG                               DEFINE 0xFF4812
REG_ON                                     DEFINE 0
LDORF_ON                                   DEFINE 1
LDORF_LEVEL                                DEFINE 2
VBATC_LEVEL                                DEFINE 4
VBATC_OUTPUT                               DEFINE 6
DC_ON                                      DEFINE 7
DC_MODE_2                                  DEFINE 9
DC_HYST                                    DEFINE 11
DC_MODE_1                                  DEFINE 12
DC_FREQ                                    DEFINE 13
DC_CLK_SEL                                 DEFINE 15

BAT_CTRL2_REG                              DEFINE 0xFF4814
CHARGE_LEVEL                               DEFINE 0
CHARGE_ON                                  DEFINE 5
NTC_DISABLE                                DEFINE 6
ONE_CELL                                   DEFINE 7
CHARGE_CUR                                 DEFINE 8
SOC_ON                                     DEFINE 11
SOC_CAL                                    DEFINE 12
SOC_TEST1                                  DEFINE 13
SOC_TEST2                                  DEFINE 14
STATUS_MODE                                DEFINE 15

BAT_STATUS_REG                             DEFINE 0xFF4816
VBAT3_STS                                  DEFINE 0
PON_STS                                    DEFINE 1
CHARGE_STS                                 DEFINE 2
CHARGE_I_LIMIT                             DEFINE 3

BAT_SOC_HIGH_REG                           DEFINE 0xFF4818

BAT_SOC_LOW_REG                            DEFINE 0xFF481A

CP_CTRL_REG                                DEFINE 0xFF481C
CP_EN                                      DEFINE 0
CP_LEVEL1                                  DEFINE 2
CP_LEVEL2                                  DEFINE 4
CP_PWM1                                    DEFINE 6
CP_PWM2                                    DEFINE 7
CP_FREQ                                    DEFINE 8
CP_PARALLEL                                DEFINE 10
CP_MODE                                    DEFINE 11
CP_TEST_ADC1                               DEFINE 12
CP_TEST_ADC2                               DEFINE 13
CP_FORCE_MODE                              DEFINE 14

PAD_CTRL_REG                               DEFINE 0xFF481E
P04567_OD                                  DEFINE 0
P023_OD                                    DEFINE 1
P001_OD                                    DEFINE 2
P27_OD                                     DEFINE 3
P225_OD                                    DEFINE 4
P234_OD                                    DEFINE 5
P21_OD                                     DEFINE 6
P20_OD                                     DEFINE 7
LED3_CUR                                   DEFINE 8
LED4_CUR                                   DEFINE 9
P4_OD                                      DEFINE 10
P5_OD                                      DEFINE 11
LED3_PWM                                   DEFINE 12
LED4_PWM                                   DEFINE 13
LED34_C_MODE                               DEFINE 14

LED_CTRL_REG                               DEFINE 0xFF4820
WLED_CUR0                                  DEFINE 0
WLED_CUR1                                  DEFINE 2
WLED_CUR2                                  DEFINE 4
WLED0_PWM                                  DEFINE 6
WLED1_PWM                                  DEFINE 7
WLED2_PWM                                  DEFINE 8
WLED_PWM_CTRL                              DEFINE 9

P0_DATA_REG                                DEFINE 0xFF4830
Px_0_DATA                                  DEFINE 0
Px_1_DATA                                  DEFINE 1
Px_2_DATA                                  DEFINE 2
Px_3_DATA                                  DEFINE 3
Px_4_DATA                                  DEFINE 4
Px_5_DATA                                  DEFINE 5
Px_6_DATA                                  DEFINE 6
Px_7_DATA                                  DEFINE 7

P0_SET_DATA_REG                            DEFINE 0xFF4832
Px_0_SET                                   DEFINE 0
Px_1_SET                                   DEFINE 1
Px_2_SET                                   DEFINE 2
Px_3_SET                                   DEFINE 3
Px_4_SET                                   DEFINE 4
Px_5_SET                                   DEFINE 5
Px_6_SET                                   DEFINE 6
Px_7_SET                                   DEFINE 7

P0_RESET_DATA_REG                          DEFINE 0xFF4834
Px_0_RESET                                 DEFINE 0
Px_1_RESET                                 DEFINE 1
Px_2_RESET                                 DEFINE 2
Px_3_RESET                                 DEFINE 3
Px_4_RESET                                 DEFINE 4
Px_5_RESET                                 DEFINE 5
Px_6_RESET                                 DEFINE 6
Px_7_RESET                                 DEFINE 7

P0_DIR_REG                                 DEFINE 0xFF4836
Px_0_DIR                                   DEFINE 0
Px_1_DIR                                   DEFINE 2
Px_2_DIR                                   DEFINE 4
Px_3_DIR                                   DEFINE 6
Px_4_DIR                                   DEFINE 8
Px_5_DIR                                   DEFINE 10
Px_6_DIR                                   DEFINE 12
Px_7_DIR                                   DEFINE 14

P0_MODE_REG                                DEFINE 0xFF4838
P0_0_MODE                                  DEFINE 0
P0_1_MODE                                  DEFINE 1
P0_2_MODE                                  DEFINE 2
P0_3_MODE                                  DEFINE 4
P0_4_MODE                                  DEFINE 6
P0_5_MODE                                  DEFINE 8
P0_6_MODE                                  DEFINE 10
P0_7_MODE                                  DEFINE 12

P1_DATA_REG                                DEFINE 0xFF4840
Px_0_DATA                                  DEFINE 0
Px_1_DATA                                  DEFINE 1
Px_2_DATA                                  DEFINE 2
Px_3_DATA                                  DEFINE 3
Px_4_DATA                                  DEFINE 4
Px_5_DATA                                  DEFINE 5
Px_6_DATA                                  DEFINE 6
Px_7_DATA                                  DEFINE 7

P1_SET_DATA_REG                            DEFINE 0xFF4842
Px_0_SET                                   DEFINE 0
Px_1_SET                                   DEFINE 1
Px_2_SET                                   DEFINE 2
Px_3_SET                                   DEFINE 3
Px_4_SET                                   DEFINE 4
Px_5_SET                                   DEFINE 5
Px_6_SET                                   DEFINE 6
Px_7_SET                                   DEFINE 7

P1_RESET_DATA_REG                          DEFINE 0xFF4844
Px_0_RESET                                 DEFINE 0
Px_1_RESET                                 DEFINE 1
Px_2_RESET                                 DEFINE 2
Px_3_RESET                                 DEFINE 3
Px_4_RESET                                 DEFINE 4
Px_5_RESET                                 DEFINE 5
Px_6_RESET                                 DEFINE 6
Px_7_RESET                                 DEFINE 7

P1_DIR_REG                                 DEFINE 0xFF4846
Px_0_DIR                                   DEFINE 0
Px_1_DIR                                   DEFINE 2
Px_2_DIR                                   DEFINE 4
Px_3_DIR                                   DEFINE 6
Px_4_DIR                                   DEFINE 8
Px_5_DIR                                   DEFINE 10
Px_6_DIR                                   DEFINE 12
Px_7_DIR                                   DEFINE 14

P1_MODE_REG                                DEFINE 0xFF4848
P1_0_MODE                                  DEFINE 0
P1_1_MODE                                  DEFINE 1
P1_2_MODE                                  DEFINE 2
P1_3_MODE                                  DEFINE 3
P1_4_MODE                                  DEFINE 4
P1_5_MODE                                  DEFINE 5
RF_BB_MODE                                 DEFINE 8

P2_DATA_REG                                DEFINE 0xFF4850
Px_0_DATA                                  DEFINE 0
Px_1_DATA                                  DEFINE 1
Px_2_DATA                                  DEFINE 2
Px_3_DATA                                  DEFINE 3
Px_4_DATA                                  DEFINE 4
Px_5_DATA                                  DEFINE 5
Px_6_DATA                                  DEFINE 6
Px_7_DATA                                  DEFINE 7

P2_SET_DATA_REG                            DEFINE 0xFF4852
Px_0_SET                                   DEFINE 0
Px_1_SET                                   DEFINE 1
Px_2_SET                                   DEFINE 2
Px_3_SET                                   DEFINE 3
Px_4_SET                                   DEFINE 4
Px_5_SET                                   DEFINE 5
Px_6_SET                                   DEFINE 6
Px_7_SET                                   DEFINE 7

P2_RESET_DATA_REG                          DEFINE 0xFF4854
Px_0_RESET                                 DEFINE 0
Px_1_RESET                                 DEFINE 1
Px_2_RESET                                 DEFINE 2
Px_3_RESET                                 DEFINE 3
Px_4_RESET                                 DEFINE 4
Px_5_RESET                                 DEFINE 5
Px_6_RESET                                 DEFINE 6
Px_7_RESET                                 DEFINE 7

P2_DIR_REG                                 DEFINE 0xFF4856
Px_0_DIR                                   DEFINE 0
Px_1_DIR                                   DEFINE 2
Px_2_DIR                                   DEFINE 4
Px_3_DIR                                   DEFINE 6
Px_4_DIR                                   DEFINE 8
Px_5_DIR                                   DEFINE 10
Px_6_DIR                                   DEFINE 12
Px_7_DIR                                   DEFINE 14

P2_MODE_REG                                DEFINE 0xFF4858
P2_2_MODE                                  DEFINE 4
P2_3_MODE                                  DEFINE 6
P2_4_MODE                                  DEFINE 8
P2_5_MODE                                  DEFINE 10
INT6_MODE                                  DEFINE 12
P2_6_MODE                                  DEFINE 13
INT7_MODE                                  DEFINE 14
P2_7_MODE                                  DEFINE 15

P3_DATA_REG                                DEFINE 0xFF4860
Px_0_DATA                                  DEFINE 0
Px_1_DATA                                  DEFINE 1
Px_2_DATA                                  DEFINE 2
Px_3_DATA                                  DEFINE 3
Px_4_DATA                                  DEFINE 4
Px_5_DATA                                  DEFINE 5
Px_6_DATA                                  DEFINE 6
Px_7_DATA                                  DEFINE 7

P3_SET_DATA_REG                            DEFINE 0xFF4862
Px_0_SET                                   DEFINE 0
Px_1_SET                                   DEFINE 1
Px_2_SET                                   DEFINE 2
Px_3_SET                                   DEFINE 3
Px_4_SET                                   DEFINE 4
Px_5_SET                                   DEFINE 5
Px_6_SET                                   DEFINE 6
Px_7_SET                                   DEFINE 7

P3_RESET_DATA_REG                          DEFINE 0xFF4864
Px_0_RESET                                 DEFINE 0
Px_1_RESET                                 DEFINE 1
Px_2_RESET                                 DEFINE 2
Px_3_RESET                                 DEFINE 3
Px_4_RESET                                 DEFINE 4
Px_5_RESET                                 DEFINE 5
Px_6_RESET                                 DEFINE 6
Px_7_RESET                                 DEFINE 7

P3_DIR_REG                                 DEFINE 0xFF4866
Px_0_DIR                                   DEFINE 0
Px_1_DIR                                   DEFINE 2
Px_2_DIR                                   DEFINE 4
Px_3_DIR                                   DEFINE 6
Px_4_DIR                                   DEFINE 8
Px_5_DIR                                   DEFINE 10
Px_6_DIR                                   DEFINE 12
Px_7_DIR                                   DEFINE 14

P3_MODE_REG                                DEFINE 0xFF4868
P3_0_MODE                                  DEFINE 0
P3_1_MODE                                  DEFINE 2
P3_2_MODE                                  DEFINE 4
P3_3_MODE                                  DEFINE 6
P3_4_MODE                                  DEFINE 8
P3_5_MODE                                  DEFINE 10
P3_6_MODE                                  DEFINE 12
P3_7_MODE                                  DEFINE 14

P4_DATA_REG                                DEFINE 0xFF4870
Px_0_DATA                                  DEFINE 0
Px_1_DATA                                  DEFINE 1
Px_2_DATA                                  DEFINE 2
Px_3_DATA                                  DEFINE 3
Px_4_DATA                                  DEFINE 4
Px_5_DATA                                  DEFINE 5
Px_6_DATA                                  DEFINE 6
Px_7_DATA                                  DEFINE 7

P4_SET_DATA_REG                            DEFINE 0xFF4872
Px_0_SET                                   DEFINE 0
Px_1_SET                                   DEFINE 1
Px_2_SET                                   DEFINE 2
Px_3_SET                                   DEFINE 3
Px_4_SET                                   DEFINE 4
Px_5_SET                                   DEFINE 5
Px_6_SET                                   DEFINE 6
Px_7_SET                                   DEFINE 7

P4_RESET_DATA_REG                          DEFINE 0xFF4874
Px_0_RESET                                 DEFINE 0
Px_1_RESET                                 DEFINE 1
Px_2_RESET                                 DEFINE 2
Px_3_RESET                                 DEFINE 3
Px_4_RESET                                 DEFINE 4
Px_5_RESET                                 DEFINE 5
Px_6_RESET                                 DEFINE 6
Px_7_RESET                                 DEFINE 7

P4_DIR_REG                                 DEFINE 0xFF4876
Px_0_DIR                                   DEFINE 0
Px_1_DIR                                   DEFINE 2
Px_2_DIR                                   DEFINE 4
Px_3_DIR                                   DEFINE 6
Px_4_DIR                                   DEFINE 8
Px_5_DIR                                   DEFINE 10
Px_6_DIR                                   DEFINE 12
Px_7_DIR                                   DEFINE 14

P4_MODE_REG                                DEFINE 0xFF4878
P4_2_MODE                                  DEFINE 0
P4_1_MODE                                  DEFINE 1

P5_DATA_REG                                DEFINE 0xFF4880
Px_0_DATA                                  DEFINE 0
Px_1_DATA                                  DEFINE 1
Px_2_DATA                                  DEFINE 2
Px_3_DATA                                  DEFINE 3
Px_4_DATA                                  DEFINE 4
Px_5_DATA                                  DEFINE 5
Px_6_DATA                                  DEFINE 6
Px_7_DATA                                  DEFINE 7

P5_SET_DATA_REG                            DEFINE 0xFF4882
Px_0_SET                                   DEFINE 0
Px_1_SET                                   DEFINE 1
Px_2_SET                                   DEFINE 2
Px_3_SET                                   DEFINE 3
Px_4_SET                                   DEFINE 4
Px_5_SET                                   DEFINE 5
Px_6_SET                                   DEFINE 6
Px_7_SET                                   DEFINE 7

P5_RESET_DATA_REG                          DEFINE 0xFF4884
Px_0_RESET                                 DEFINE 0
Px_1_RESET                                 DEFINE 1
Px_2_RESET                                 DEFINE 2
Px_3_RESET                                 DEFINE 3
Px_4_RESET                                 DEFINE 4
Px_5_RESET                                 DEFINE 5
Px_6_RESET                                 DEFINE 6
Px_7_RESET                                 DEFINE 7

P5_DIR_REG                                 DEFINE 0xFF4886
Px_0_DIR                                   DEFINE 0
Px_1_DIR                                   DEFINE 2
Px_2_DIR                                   DEFINE 4
Px_3_DIR                                   DEFINE 6
Px_4_DIR                                   DEFINE 8
Px_5_DIR                                   DEFINE 10
Px_6_DIR                                   DEFINE 12
Px_7_DIR                                   DEFINE 14

P5_MODE_REG                                DEFINE 0xFF4888
P5_MODE                                    DEFINE 0

PORT_TRACE_CTRL_REG                        DEFINE 0xFF48E0
TRACE_EXT0                                 DEFINE 0
TRACE_EXT1                                 DEFINE 5

UART_CTRL_REG                              DEFINE 0xFF4900
UART_REN                                   DEFINE 0
UART_TEN                                   DEFINE 1
BAUDRATE                                   DEFINE 2
TI                                         DEFINE 5
RI                                         DEFINE 6
UART_MODE                                  DEFINE 7
IRDA_EN                                    DEFINE 8
INV_URX                                    DEFINE 9
INV_UTX                                    DEFINE 10

UART_RX_TX_REG                             DEFINE 0xFF4902

UART_CLEAR_TX_INT_REG                      DEFINE 0xFF4904

UART_CLEAR_RX_INT_REG                      DEFINE 0xFF4906

UART_ERROR_REG                             DEFINE 0xFF4908
PAR_STATUS                                 DEFINE 0
DMA_PARITY_ERROR                           DEFINE 1

UART2_CTRL_REG                             DEFINE 0xFF4910
UART_REN                                   DEFINE 0
UART_TEN                                   DEFINE 1
BAUDRATE                                   DEFINE 2
TI                                         DEFINE 5
RI                                         DEFINE 6
UART_MODE                                  DEFINE 7
IRDA_EN                                    DEFINE 8
INV_URX                                    DEFINE 9
INV_UTX                                    DEFINE 10

UART2_RX_TX_REG                            DEFINE 0xFF4912

UART2_CLEAR_TX_INT_REG                     DEFINE 0xFF4914

UART2_CLEAR_RX_INT_REG                     DEFINE 0xFF4916

UART2_ERROR_REG                            DEFINE 0xFF4918
PAR_STATUS                                 DEFINE 0
DMA_PARITY_ERROR                           DEFINE 1

ACCESS1_IN_OUT_REG                         DEFINE 0xFF4920

ACCESS1_CTRL_REG                           DEFINE 0xFF4922
EN_ACCESS_BUS                              DEFINE 0
ACKn                                       DEFINE 1
SCL_VAL                                    DEFINE 2
SDA_VAL                                    DEFINE 3
ACCESSx_INT                                DEFINE 4
EN_ACCESS_INT                              DEFINE 5
SCL_OD                                     DEFINE 6
SDA_OD                                     DEFINE 7
SCK_NUM                                    DEFINE 8
SCK_SEL                                    DEFINE 9

ACCESS1_CLEAR_INT_REG                      DEFINE 0xFF4924

ACCESS2_IN_OUT_REG                         DEFINE 0xFF4930

ACCESS2_CTRL_REG                           DEFINE 0xFF4932
EN_ACCESS_BUS                              DEFINE 0
ACKn                                       DEFINE 1
SCL_VAL                                    DEFINE 2
SDA_VAL                                    DEFINE 3
ACCESSx_INT                                DEFINE 4
EN_ACCESS_INT                              DEFINE 5
SCL_OD                                     DEFINE 6
SDA_OD                                     DEFINE 7
SCK_NUM                                    DEFINE 8
SCK_SEL                                    DEFINE 9

ACCESS2_CLEAR_INT_REG                      DEFINE 0xFF4934

SPI_CTRL_REG                               DEFINE 0xFF4940
SPI_ON                                     DEFINE 0
SPI_PHA                                    DEFINE 1
SPI_POL                                    DEFINE 2
SPI_CLK                                    DEFINE 3
SPI_DO                                     DEFINE 5
SPI_SMN                                    DEFINE 6
SPI_WORD                                   DEFINE 7
SPI_RST                                    DEFINE 9
SPI_FORCE_DO                               DEFINE 10
SPI_TXH                                    DEFINE 11
SPI_DI                                     DEFINE 12
SPI_INT_BIT                                DEFINE 13
SPI_MINT                                   DEFINE 14
SPI_EN_CTRL                                DEFINE 15

SPI_RX_TX_REG0                             DEFINE 0xFF4942

SPI_RX_TX_REG1                             DEFINE 0xFF4944

SPI_CLEAR_INT_REG                          DEFINE 0xFF4946

SPI_CTRL_REG1                              DEFINE 0xFF4948
SPI_FIFO_MODE                              DEFINE 0
SPI_PRIORITY                               DEFINE 2
SPI_BUSY                                   DEFINE 3

SPI2_CTRL_REG                              DEFINE 0xFF4950
SPI_ON                                     DEFINE 0
SPI_PHA                                    DEFINE 1
SPI_POL                                    DEFINE 2
SPI_CLK                                    DEFINE 3
SPI_DO                                     DEFINE 5
SPI_SMN                                    DEFINE 6
SPI_WORD                                   DEFINE 7
SPI_RST                                    DEFINE 9
SPI_FORCE_DO                               DEFINE 10
SPI_TXH                                    DEFINE 11
SPI_DI                                     DEFINE 12
SPI_INT_BIT                                DEFINE 13
SPI_MINT                                   DEFINE 14
SPI_EN_CTRL                                DEFINE 15

SPI2_RX_TX_REG0                            DEFINE 0xFF4952

SPI2_RX_TX_REG1                            DEFINE 0xFF4954

SPI2_CLEAR_INT_REG                         DEFINE 0xFF4956

SPI2_CTRL_REG1                             DEFINE 0xFF4958
SPI_FIFO_MODE                              DEFINE 0
SPI_PRIORITY                               DEFINE 2
SPI_BUSY                                   DEFINE 3

ADC_CTRL_REG                               DEFINE 0xFF4960
ADC_START                                  DEFINE 0
ADC_ALT                                    DEFINE 2
ADC_IN_3_0                                 DEFINE 3
ADC_TEST                                   DEFINE 7
ADC_INT                                    DEFINE 11
ADC_MINT                                   DEFINE 12
ADC0_PR_DIS                                DEFINE 13
ADC1_PR_DIS                                DEFINE 14
ADC2_PR_DIS                                DEFINE 15

ADC_CTRL1_REG                              DEFINE 0xFF4962
ADC_IN_3_0_1                               DEFINE 0

ADC_CLEAR_INT_REG                          DEFINE 0xFF4964

ADC0_REG                                   DEFINE 0xFF4966
ADC0_VAL                                   DEFINE 0

ADC1_REG                                   DEFINE 0xFF4968
ADC1_VAL                                   DEFINE 0

TIMER_CTRL_REG                             DEFINE 0xFF4970
TIM0_CTRL                                  DEFINE 0
TIM1_CTRL                                  DEFINE 1
CLK_CTRL0                                  DEFINE 2
CLK_CTRL1                                  DEFINE 3
WDOG_CTRL                                  DEFINE 4
TIM1_MODE                                  DEFINE 5
CLK_DIV8                                   DEFINE 6
TIM2_CTRL                                  DEFINE 7

TIMER0_ON_REG                              DEFINE 0xFF4972

TIMER0_RELOAD_M_REG                        DEFINE 0xFF4974

TIMER0_RELOAD_N_REG                        DEFINE 0xFF4976

TIMER1_RELOAD_M_REG                        DEFINE 0xFF4978

TIMER1_RELOAD_N_REG                        DEFINE 0xFF497A

TIMER2_DUTY1_REG                           DEFINE 0xFF497C
TIM2_DUTY1                                 DEFINE 0

TIMER2_DUTY2_REG                           DEFINE 0xFF497E
TIM2_DUTY2                                 DEFINE 0

TIMER2_FREQ_REG                            DEFINE 0xFF4980
TIM2_FREQ                                  DEFINE 0

TIMER2_DUTY3_REG                           DEFINE 0xFF4982
TIM2_DUTY3                                 DEFINE 0

TONE_CTRL1_REG                             DEFINE 0xFF4990
GATESRC1                                   DEFINE 0
CLKSRC1                                    DEFINE 2
TIMER_RELOAD1                              DEFINE 4
CT1_INT                                    DEFINE 8
MCT1_INT                                   DEFINE 9
GATE_EDGE1                                 DEFINE 10

TONE_COUNTER1_REG                          DEFINE 0xFF4992

TONE_LATCH1_REG                            DEFINE 0xFF4994

TONE_CLEAR_INT1_REG                        DEFINE 0xFF4996

TONE_CTRL2_REG                             DEFINE 0xFF4998
GATESRC2                                   DEFINE 0
CLKSRC2                                    DEFINE 2
TIMER_RELOAD2                              DEFINE 4
CT2_INT                                    DEFINE 8
MCT2_INT                                   DEFINE 9
GATE_EDGE2                                 DEFINE 10

TONE_COUNTER2_REG                          DEFINE 0xFF499A

TONE_LATCH2_REG                            DEFINE 0xFF499C

TONE_CLEAR_INT2_REG                        DEFINE 0xFF499E

KEY_GP_INT_REG                             DEFINE 0xFF49B0
INT6_CTRL                                  DEFINE 0
INT7_CTRL                                  DEFINE 3
INT8_CTRL                                  DEFINE 6

KEY_BOARD_INT_REG                          DEFINE 0xFF49B2
INT0_EN                                    DEFINE 0
INT1_EN                                    DEFINE 1
INT2_EN                                    DEFINE 2
INT3_EN                                    DEFINE 3
INT4_EN                                    DEFINE 4
INT5_EN                                    DEFINE 5
INT_CHARGE_EN                              DEFINE 6
INT_PON_EN                                 DEFINE 7
CHARGE_CTRL                                DEFINE 8
PON_CTRL                                   DEFINE 9
KEY_LEVEL                                  DEFINE 10
KEY_REL                                    DEFINE 11
CHARGE_EDGE                                DEFINE 12
VBATC_EDGE                                 DEFINE 13
VBATC_EN                                   DEFINE 14

KEY_DEBOUNCE_REG                           DEFINE 0xFF49B4
DEBOUNCE                                   DEFINE 0
KEY_REPEAT                                 DEFINE 6

KEY_STATUS_REG                             DEFINE 0xFF49B6
KEY_STATUS                                 DEFINE 0

ULP_CTRL_REG                               DEFINE 0xFF4A00
ULP_ENABLE                                 DEFINE 0
ULP_MAIN_SLEEP                             DEFINE 1
ULP_TIMER_ON                               DEFINE 2
ULP_TIMER_WEN                              DEFINE 3
ULP_TIMER_REN                              DEFINE 4
ULP_TRIG_EN                                DEFINE 5
ULP_XTAL_ON                                DEFINE 6
ULP_OSC_ON                                 DEFINE 7
ULP_CLK_SEL                                DEFINE 8
ULP_LATCH_CNT                              DEFINE 9

ULP_TRIG_REG                               DEFINE 0xFF4A02
ULP_TRIG                                   DEFINE 0

ULP_PORT_REG                               DEFINE 0xFF4A04
ULP_PORT_VAL                               DEFINE 0
ULP_PORT_DIR                               DEFINE 1
ULP_PORT_IE                                DEFINE 3
ULP_PORT_TRIG                              DEFINE 4
ULP_PORT_WEN                               DEFINE 6
ULP_PORT_MODE                              DEFINE 7

ULP_PHASE_REG                              DEFINE 0xFF4A06
ULP_PHASE                                  DEFINE 0
ULP_PH_BUSY                                DEFINE 15

ULP_TIMERL_REG                             DEFINE 0xFF4A08

ULP_TIMERH_REG                             DEFINE 0xFF4A0A

ULP_WAKEUPL_REG                            DEFINE 0xFF4A0C

ULP_WAKEUPH_REG                            DEFINE 0xFF4A0E

ULP_STATUS_REG                             DEFINE 0xFF4A10
ULP_TIMER_STS                              DEFINE 0
ULP_PORT_STS                               DEFINE 1
ULP_TIMER_STSR                             DEFINE 2
ULP_PORT_STSR                              DEFINE 3
ULP_XTAL_VAL                               DEFINE 4
ULP_XTAL_OK                                DEFINE 5
ULP_OSC_VAL                                DEFINE 6
ULP_WAKEUP_VAL                             DEFINE 7
ULP_TRIG_VAL                               DEFINE 8

ULP_TEST_REG                               DEFINE 0xFF4A12

WATCHDOG_REG                               DEFINE 0xFF4C00

SET_FREEZE_REG                             DEFINE 0xFF5000
FRZ_DIP                                    DEFINE 0
FRZ_TIM0                                   DEFINE 1
FRZ_TIM1                                   DEFINE 2
FRZ_WDOG                                   DEFINE 3
FRZ_DMA0                                   DEFINE 4
FRZ_DMA1                                   DEFINE 5
FRZ_DMA2                                   DEFINE 6
FRZ_DMA3                                   DEFINE 7

RESET_FREEZE_REG                           DEFINE 0xFF5002
FRZ_DIP                                    DEFINE 0
FRZ_TIM0                                   DEFINE 1
FRZ_TIM1                                   DEFINE 2
FRZ_WDOG                                   DEFINE 3
FRZ_DMA0                                   DEFINE 4
FRZ_DMA1                                   DEFINE 5
FRZ_DMA2                                   DEFINE 6
FRZ_DMA3                                   DEFINE 7

DEBUG_REG                                  DEFINE 0xFF5004
CLK100_EDGE                                DEFINE 0
CLK100_NEG                                 DEFINE 1
CLK100_POS                                 DEFINE 2
CLK100_SRC                                 DEFINE 3
ENV_B01                                    DEFINE 4
SW_RESET                                   DEFINE 7
CR16_DBGM                                  DEFINE 11
ALIAS_DIPRAM                               DEFINE 12
OWI_SEL_SYNC                               DEFINE 13

CACHE_CTRL_REG                             DEFINE 0xFF5010
CACHE_SIZE                                 DEFINE 0
CACHE_MODE                                 DEFINE 4
CACHE_LOCK                                 DEFINE 6
ICACHE_B_SIZE                              DEFINE 8
DCACHE_B_SIZE                              DEFINE 10

CACHE_LEN0_REG                             DEFINE 0xFF5012
CACHE_LEN0                                 DEFINE 0

CACHE_START0_REG                           DEFINE 0xFF5014
CACHE_START0                               DEFINE 0

CACHE_LEN1_REG                             DEFINE 0xFF5016
CACHE_LEN1                                 DEFINE 0

CACHE_START1_REG                           DEFINE 0xFF5018
CACHE_START1                               DEFINE 0

CACHE_STATUS_REG                           DEFINE 0xFF501A
ICACHE_HIT                                 DEFINE 10
DCACHE_HIT                                 DEFINE 11
CACHE_TOUCH_TOGGLE                         DEFINE 12
CACHE_TOUCH                                DEFINE 13

CACHE_TEST_REG                             DEFINE 0xFF501C

TRACE_CTRL_REG                             DEFINE 0xFF5020
TRACE_SIZE                                 DEFINE 0
TRACE_COND                                 DEFINE 3
EXT_EVENTS_ON                              DEFINE 4
DIP_EVENTS_ON                              DEFINE 5
DSP_EVENTS_ON                              DEFINE 6
BUS_EVENTS_ON                              DEFINE 7
D_TRACE_EV_ON                              DEFINE 8
I_TRACE_EV_ON                              DEFINE 9
D_TRACE_ON                                 DEFINE 10
I_TRACE_ON                                 DEFINE 11
TRACE_COND_EXT                             DEFINE 12
TRACE_MODE                                 DEFINE 15

TRACE_STATUS_REG                           DEFINE 0xFF5022
TRACE_IDX                                  DEFINE 0
TRACE_TOUCH_TOGGLE                         DEFINE 13
TRACE_EOB                                  DEFINE 14
TRACE_BUSY                                 DEFINE 15

TRACE_START0_REG                           DEFINE 0xFF5024
TRACE_START0                               DEFINE 0

TRACE_LEN0_REG                             DEFINE 0xFF5026
TRACE_LEN0                                 DEFINE 0

TRACE_START1_REG                           DEFINE 0xFF5028
TRACE_START1                               DEFINE 0

TRACE_LEN1_REG                             DEFINE 0xFF502A
TRACE_LEN1                                 DEFINE 0

TRACE_TIMERL_REG                           DEFINE 0xFF502C

TRACE_TIMERH_REG                           DEFINE 0xFF502E

SET_INT_PENDING_REG                        DEFINE 0xFF5400
ACCESS_INT_PEND                            DEFINE 0
KEYB_INT_PEND                              DEFINE 1
UART2_RI_TI_INT_PEND                       DEFINE 2
CT_CLASSD_INT_PEND                         DEFINE 3
UART_RI_INT_PEND                           DEFINE 4
UART_TI_INT_PEND                           DEFINE 5
SPI_INT_PEND                               DEFINE 6
TIM0_INT_PEND                              DEFINE 7
TIM1_INT_PEND                              DEFINE 8
CLK100_INT_PEND                            DEFINE 9
DIP_INT_PEND                               DEFINE 10
AD_INT_PEND                                DEFINE 11
SPI2_INT_PEND                              DEFINE 12
DSP_INT_PEND                               DEFINE 13
ULP_INT_PEND                               DEFINE 14

RESET_INT_PENDING_REG                      DEFINE 0xFF5402
ACCESS_INT_PEND                            DEFINE 0
KEYB_INT_PEND                              DEFINE 1
UART2_RI_TI_INT_PEND                       DEFINE 2
CT_CLASSD_INT_PEND                         DEFINE 3
UART_RI_INT_PEND                           DEFINE 4
UART_TI_INT_PEND                           DEFINE 5
SPI_INT_PEND                               DEFINE 6
TIM0_INT_PEND                              DEFINE 7
TIM1_INT_PEND                              DEFINE 8
CLK100_INT_PEND                            DEFINE 9
DIP_INT_PEND                               DEFINE 10
AD_INT_PEND                                DEFINE 11
SPI2_INT_PEND                              DEFINE 12
DSP_INT_PEND                               DEFINE 13
ULP_INT_PEND                               DEFINE 14

INT0_PRIORITY_REG                          DEFINE 0xFF5404
SPI2_INT_PRIO                              DEFINE 0
DSP_INT_PRIO                               DEFINE 4
ULP_INT_PRIO                               DEFINE 8

INT1_PRIORITY_REG                          DEFINE 0xFF5406
TIM1_INT_PRIO                              DEFINE 0
CLK100_INT_PRIO                            DEFINE 4
DIP_INT_PRIO                               DEFINE 8
AD_INT_PRIO                                DEFINE 12

INT2_PRIORITY_REG                          DEFINE 0xFF5408
UART_RI_INT_PRIO                           DEFINE 0
UART_TI_INT_PRIO                           DEFINE 4
SPI_INT_PRIO                               DEFINE 8
TIM0_INT_PRIO                              DEFINE 12

INT3_PRIORITY_REG                          DEFINE 0xFF540A
ACCESS_INT_PRIO                            DEFINE 0
KEYB_INT_PRIO                              DEFINE 4
UART2_RI_TI_INT_PRIO                       DEFINE 8
CT_CLASSD_INT_PRIO                         DEFINE 12

PC_START_REG                               DEFINE 0xFF540C
PC_START10                                 DEFINE 0
PC_START                                   DEFINE 2

CODEC_MIC_REG                              DEFINE 0xFF5800
MIC_MODE                                   DEFINE 0
MIC_PD                                     DEFINE 2
MIC_MUTE                                   DEFINE 3
MIC_GAIN                                   DEFINE 4
MIC_OFFCOM_SG                              DEFINE 8
MIC_OFFCOM_ON                              DEFINE 9
DSP_CTRL                                   DEFINE 10
MICH_ON                                    DEFINE 11
MIC_CADJ                                   DEFINE 12
MICHP_ON                                   DEFINE 14
MIC_LSR_ON                                 DEFINE 15

CODEC_LSR_REG                              DEFINE 0xFF5802
LSRP_MODE                                  DEFINE 0
LSRP_PD                                    DEFINE 2
LSRN_MODE                                  DEFINE 3
LSRN_PD                                    DEFINE 5
LSRATT                                     DEFINE 6
LSREN_SE                                   DEFINE 9

CODEC_VREF_REG                             DEFINE 0xFF5804
VREF_PD                                    DEFINE 0
VREF_FILT_PD                               DEFINE 1
VREF_FILT_CADJ                             DEFINE 2
VREF_INIT                                  DEFINE 4
AMP1V5_PD                                  DEFINE 5
VREF_BG_PD                                 DEFINE 6
BIAS_PD                                    DEFINE 7
AGND_LSR_PD                                DEFINE 8
REFINT_PD                                  DEFINE 9

CODEC_TONE_REG                             DEFINE 0xFF5806
CID_PD                                     DEFINE 0
CID_PR_DIS                                 DEFINE 1
RNG_PD                                     DEFINE 2
RNG_PR_DIS                                 DEFINE 3
PARA_PD                                    DEFINE 4
PARA_PR_DIS                                DEFINE 5
RNG_CMP_PD                                 DEFINE 6

CODEC_ADDA_REG                             DEFINE 0xFF5808
DA_PD                                      DEFINE 0
AD_PD                                      DEFINE 1
DA_CADJ                                    DEFINE 2
AD_CADJ                                    DEFINE 4
DA_DITH_OFF                                DEFINE 6
AD_DITH_OFF                                DEFINE 7
DA_HBW                                     DEFINE 8
LPF_PD                                     DEFINE 9
LPF_BW                                     DEFINE 10
ADC_VREF_LSR                               DEFINE 13
AUTO_SYNC                                  DEFINE 15

CODEC_OFFSET1_REG                          DEFINE 0xFF580A

CODEC_TEST_CTRL_REG                        DEFINE 0xFF580C

CODEC_OFFSET2_REG                          DEFINE 0xFF580E

CODEC_MIC2_REG                             DEFINE 0xFF5810
MIC2_PD                                    DEFINE 0
MIC2_MUTE                                  DEFINE 1
MIC2_OFFCOM_SG                             DEFINE 2
MIC2_OFFCOM_ON                             DEFINE 3
MIC2_GAIN                                  DEFINE 4
MIC2_PMUX                                  DEFINE 8
MIC2_NMUX                                  DEFINE 11
MIC2_CADJ                                  DEFINE 14

CODEC_MIC2_OFFSET1_REG                     DEFINE 0xFF5812

CODEC_MIC2_OFFSET2_REG                     DEFINE 0xFF5814

CODEC_MIC_AUTO_REG                         DEFINE 0xFF5816
MIC_CONFIG                                 DEFINE 0

CODEC_LSR_AUTO_REG                         DEFINE 0xFF5818
LSR_CONFIG                                 DEFINE 0

CLASSD_CTRL_REG                            DEFINE 0xFF5C00
CLASSD_PD                                  DEFINE 0
CLASSD_PROT                                DEFINE 1
CLASSD_VOUT                                DEFINE 2
CLASSD_CLIP                                DEFINE 4
CLASSD_INT_BIT                             DEFINE 7
CLASSD_DITH_D                              DEFINE 8
CLASSD_DITH_A                              DEFINE 10
CLASSD_MODE                                DEFINE 12
CLASSD_MINT                                DEFINE 13
CLASSD_MOPEN                               DEFINE 14
CLASSD_POPEN                               DEFINE 15

CLASSD_CLEAR_INT_REG                       DEFINE 0xFF5C02

CLASSD_BUZZER_REG                          DEFINE 0xFF5C04
CLASSD_BUZ_GAIN                            DEFINE 0
CLASSD_BUZ_MODE                            DEFINE 4

CLASSD_TEST_REG                            DEFINE 0xFF5C06
CLASSD_SWITCH                              DEFINE 0
CLASSD_RST_D                               DEFINE 1
CLASSD_RST_A                               DEFINE 2
CLASSD_FORCE                               DEFINE 3
CLASSD_ANA_TEST                            DEFINE 4

CLASSD_NR_REG                              DEFINE 0xFF5C08
CLASSD_NR_ACTIVE                           DEFINE 0
CLASSD_NR_LVL                              DEFINE 1
CLASSD_NR_TON                              DEFINE 4
CLASSD_NR_HYST                             DEFINE 8
CLASSD_NR_ZERO                             DEFINE 10
CLASSD_NR_MODE                             DEFINE 12

CLASSD_MIC2_REG                            DEFINE 0xFF5C0A
MIC2_AD_ON                                 DEFINE 0
MIC2_PAOUT                                 DEFINE 1
MIC2_PAOUT_GAIN                            DEFINE 2
MIC2_PAOUT_PSRR                            DEFINE 3
PAOUT_INPUT                                DEFINE 4

DIP_STACK_REG                              DEFINE 0xFF6000
STACK_REG                                  DEFINE 0
STACK_BANK                                 DEFINE 8

DIP_PC_REG                                 DEFINE 0xFF6002
DIP_PC                                     DEFINE 0
DIP_BANK                                   DEFINE 8

DIP_STATUS_REG                             DEFINE 0xFF6004
DIP_INT_VEC                                DEFINE 0
PD1_INT                                    DEFINE 4
DIP_BRK_INT                                DEFINE 5
PRESCALER                                  DEFINE 6
URST                                       DEFINE 7

DIP_CTRL_REG                               DEFINE 0xFF6006
DIP_INT_VEC                                DEFINE 0
PD1_INT                                    DEFINE 4
DIP_BRK_INT                                DEFINE 5
PRESCALER                                  DEFINE 6
URST                                       DEFINE 7

DIP_STATUS1_REG                            DEFINE 0xFF6008
DIP_VNMI_VEC                               DEFINE 0

DIP_CTRL1_REG                              DEFINE 0xFF600A
DIP_VNMI_VEC                               DEFINE 0

DIP_SLOT_NUMBER_REG                        DEFINE 0xFF600C
SLOT_CNTER                                 DEFINE 0

DIP_CTRL2_REG                              DEFINE 0xFF600E
DBUF                                       DEFINE 0
PRE_ACT                                    DEFINE 1
BRK_PRE_OVR                                DEFINE 2
PD1_INT                                    DEFINE 4
DIP_BRK                                    DEFINE 5
EN_8DIV9                                   DEFINE 7
SLOTCNT_RES                                DEFINE 8
FR_BMC                                     DEFINE 9
MFR_DSC                                    DEFINE 10
ZERO_DSC                                   DEFINE 11

DIP_MOD_SEL_REG                            DEFINE 0xFF6012
ARMOD0                                     DEFINE 0
ARMOD1                                     DEFINE 1
ARMOD2                                     DEFINE 2
ARMOD3                                     DEFINE 3
AWMOD0                                     DEFINE 4
AWMOD1                                     DEFINE 5
AWMOD2                                     DEFINE 6
AWMOD3                                     DEFINE 7

DIP_MOD_VAL_REG                            DEFINE 0xFF6014

DIP_DC01_REG                               DEFINE 0xFF6016
FRAME                                      DEFINE 0
MFRAME_LOW                                 DEFINE 4

DIP_DC23_REG                               DEFINE 0xFF6018
MFRAME_HIGH                                DEFINE 0

DIP_DC34_REG                               DEFINE 0xFF601A

BMC_CTRL_REG                               DEFINE 0xFF6400
SIO_PD                                     DEFINE 8
BCNT_INH                                   DEFINE 13

BMC_CTRL2_REG                              DEFINE 0xFF6402
RCV_CTL                                    DEFINE 3
RCK_SEL                                    DEFINE 8
BF_CNT_HLD                                 DEFINE 9

BMC_TX_SFIELDL_REG                         DEFINE 0xFF6404

BMC_TX_SFIELDH_REG                         DEFINE 0xFF6406

BMC_RX_SFIELDL_REG                         DEFINE 0xFF6408

BMC_RX_SFIELDH_REG                         DEFINE 0xFF640A

RF_BURST_MODE_CTRL_REG                     DEFINE 0xFF7000
CN                                         DEFINE 0
RFCAL                                      DEFINE 7
RSSI_MODE                                  DEFINE 13
FAD                                        DEFINE 14
RX_TX                                      DEFINE 16

RF_ALW_EN_REG                              DEFINE 0xFF7008
PA_FINAL_STAGE_ALW_EN                      DEFINE 0
PA_DRIVER_STAGE_ALW_EN                     DEFINE 1
PORT2_ALW_EN                               DEFINE 2
PORT1_ALW_EN                               DEFINE 3
PLLCLOSED_ALW_EN                           DEFINE 4
SYNTH_ALW_EN                               DEFINE 5
BIAS_ALW_EN                                DEFINE 6
RSSIPH_ALW_EN                              DEFINE 7
DEM_ALW_EN                                 DEFINE 8
ADC_ALW_EN                                 DEFINE 9
IF_ALW_EN                                  DEFINE 10
LNAMIX_ALW_EN                              DEFINE 11
PA_ALW_EN                                  DEFINE 12

RF_PORT_RSSI_SI_REG                        DEFINE 0xFF700A

RF_TX_SI_REG                               DEFINE 0xFF700C

RF_RX_SI_REG                               DEFINE 0xFF700E

RF_PORT1_DCF_REG                           DEFINE 0xFF7010
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
EN_BY_TX                                   DEFINE 12
EN_BY_RX                                   DEFINE 13
SSI                                        DEFINE 14

RF_PORT2_DCF_REG                           DEFINE 0xFF7012
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
EN_BY_TX                                   DEFINE 12
EN_BY_RX                                   DEFINE 13
SSI                                        DEFINE 14

RF_PA_DRIVER_STAGE_DCF_REG                 DEFINE 0xFF7014
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
EN_BY_TX                                   DEFINE 12
EN_BY_RX                                   DEFINE 13
SSI                                        DEFINE 14

RF_PA_FINAL_STAGE_DCF_REG                  DEFINE 0xFF7016
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
EN_BY_TX                                   DEFINE 12
EN_BY_RX                                   DEFINE 13
SSI                                        DEFINE 14

RF_PLLCLOSED_DCF_REG                       DEFINE 0xFF7018
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
DIS                                        DEFINE 12
SSI                                        DEFINE 14

RF_SYNTH_DCF_REG                           DEFINE 0xFF701A
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
DIS                                        DEFINE 12

RF_BIAS_DCF_REG                            DEFINE 0xFF701C
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
DIS                                        DEFINE 12

RF_RSSIPH_DCF_REG                          DEFINE 0xFF701E
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
DIS                                        DEFINE 12

RF_DEM_DCF_REG                             DEFINE 0xFF7020
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
DIS                                        DEFINE 12
SSI                                        DEFINE 14

RF_ADC_DCF_REG                             DEFINE 0xFF7022
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
DIS                                        DEFINE 12
SSI                                        DEFINE 14

RF_IF_DCF_REG                              DEFINE 0xFF7024
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
DIS                                        DEFINE 12
SSI                                        DEFINE 14

RF_LNAMIX_DCF_REG                          DEFINE 0xFF7026
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
DIS                                        DEFINE 12
SSI                                        DEFINE 14

RF_PA_DCF_REG                              DEFINE 0xFF7028
SET_OFFSET                                 DEFINE 0
RESET_OFFSET                               DEFINE 6
DIS                                        DEFINE 12
RX_SENSITIVE                               DEFINE 13
PADR_SSI                                   DEFINE 14

RF_FAD_WINDOW_DCF_REG                      DEFINE 0xFF702A
FAD_SWAP                                   DEFINE 0
FAD_DECIDE                                 DEFINE 6

RF_RFCAL_CTRL_REG                          DEFINE 0xFF7040
RFCAL_STEPS                                DEFINE 0
RFCAL_MODE                                 DEFINE 3
RFCAL_PERIOD                               DEFINE 5

RF_DEM_CTRL_REG                            DEFINE 0xFF7044
DEM_INVERT                                 DEFINE 0
SLICE_EN                                   DEFINE 1
SLICE_EARLY                                DEFINE 7
SLICE_VAL                                  DEFINE 8

RF_PREAMBLE_REG                            DEFINE 0xFF7046
PREAMBLE_DEL                               DEFINE 0
AFC_VAL                                    DEFINE 6
AFC_EN                                     DEFINE 8
AFC_SETTLE_DEL                             DEFINE 9
PREAMBLE_SYM                               DEFINE 11
GATE_DATA                                  DEFINE 13
HALF_BIT_RATE                              DEFINE 14
SYNC_RX_DATA                               DEFINE 15

RF_RSSI_REG                                DEFINE 0xFF7048
RFCAL_CAP                                  DEFINE 0
RSSI_VAL                                   DEFINE 8
FAD_CHOICE                                 DEFINE 14

RF_PORT_CTRL_REG                           DEFINE 0xFF704A
PORT1_INV                                  DEFINE 0
ANT_INACTIVE_VAL                           DEFINE 4

RF_PAD_IO_REG                              DEFINE 0xFF704C
P0_OE                                      DEFINE 0
P0N_OE                                     DEFINE 1
P1_OE                                      DEFINE 2
P2_OE                                      DEFINE 3
P0_IE                                      DEFINE 6
PAD_OE                                     DEFINE 0

RF_PLL_CTRL1_REG                           DEFINE 0xFF7050
CH_ZERO                                    DEFINE 0
SGN_NEG                                    DEFINE 13
CS_MO                                      DEFINE 14

RF_PLL_CTRL2_REG                           DEFINE 0xFF7052
GAUSS_GAIN                                 DEFINE 0
MODINDEX                                   DEFINE 8
MODE20M                                    DEFINE 14

RF_PLL_CTRL3_REG                           DEFINE 0xFF7054
FASTLOCK_PERIOD                            DEFINE 0
FASTLOCK                                   DEFINE 10
LOCK_TIME                                  DEFINE 11

RF_PLL_CTRL4_REG                           DEFINE 0xFF7056
MODCAL_PERIOD                              DEFINE 0
MODCAL_TRIG                                DEFINE 8
SD2_ORDER                                  DEFINE 11
KMOD_ALPHA                                 DEFINE 13

RF_SLICER_REG                              DEFINE 0xFF7058
TRACK_SLICE                                DEFINE 0
DECIDE_ON_AVG                              DEFINE 1
SLICE_LOW                                  DEFINE 2

RF_SLICER_RESULT_REG                       DEFINE 0xFF705A
AFC_VAL                                    DEFINE 6
SLICE_VAL                                  DEFINE 8

RF_GAUSS_GAIN_RESULT_REG                   DEFINE 0xFF705C

RF_BURST_MODE_SHADOW1_REG                  DEFINE 0xFF7070
CN_SHW                                     DEFINE 0
RFCAL_SHW                                  DEFINE 8
RSSI_MODE_SHW                              DEFINE 14

RF_BURST_MODE_SHADOW2_REG                  DEFINE 0xFF7072
FAD_SHW                                    DEFINE 0
TX_ASSERT                                  DEFINE 2
RX_ASSERT                                  DEFINE 3
SHADOW_EN                                  DEFINE 4

RF_DCF_MONITOR_REG                         DEFINE 0xFF7074
DP0_SEL                                    DEFINE 0
DP1_SEL                                    DEFINE 4
DP2_SEL                                    DEFINE 8
DP3_SEL                                    DEFINE 12

RF_SYNTH_CTRL1_REG                         DEFINE 0xFF7080

RF_SYNTH_CTRL2_REG                         DEFINE 0xFF7082

RF_AGC_REG                                 DEFINE 0xFF7084

RF_AGC12_TH_REG                            DEFINE 0xFF7086

RF_AGC12_ALPHA_REG                         DEFINE 0xFF7088

RF_POSITIONING_REG                         DEFINE 0xFF708A

RF_DC_OFFSET_REG                           DEFINE 0xFF708C

RF_DC_OFFSET34_REG                         DEFINE 0xFF708E

RF_IQ_DC_OFFSET_REG                        DEFINE 0xFF7090

RF_IF_CTRL_REG                             DEFINE 0xFF7092

RF_REF_OSC_REG                             DEFINE 0xFF7094

RF_ADC_CTRL_REG                            DEFINE 0xFF7096

RF_RFIO_CTRL_REG                           DEFINE 0xFF7098

RF_BIAS_CTRL_REG                           DEFINE 0xFF709A

RF_DRIFT_TEST_REG                          DEFINE 0xFF709C

RF_TEST_MODE_REG                           DEFINE 0xFF709E

RF_LDO_TEST_REG                            DEFINE 0xFF70A0

RF_PLL_CTRL5_REG                           DEFINE 0xFF70AC

RF_PLL_CTRL6_REG                           DEFINE 0xFF70AE

RF_BBADC_CTRL_REG                          DEFINE 0xFF70B0
RF_BBADC_TEST1                             DEFINE 0
PA_CASCODE_LEVEL                           DEFINE 3
RF_BBADC_TEST0                             DEFINE 6

RF_PA_CTRL1_REG                            DEFINE 0xFF70B2
PA_CUR_SET1                                DEFINE 4
PA_CUR_SET2                                DEFINE 8
PA_ATT_SET                                 DEFINE 12

RF_PA_CTRL2_REG                            DEFINE 0xFF70B4
RAMP_SPEED1                                DEFINE 8
RAMP_SPEED2                                DEFINE 12

RF_IFCAL_RESULT_REG                        DEFINE 0xFF70B6

RF_DC_OFFSET12_REG                         DEFINE 0xFF70B8

RF_AGC_RESULT_REG                          DEFINE 0xFF70BA

RF_GAUSS_GAIN_MSB_REG                      DEFINE 0xFF70BC

RF_RXFE_CTRL_REG                           DEFINE 0xFF70BE

RF_FAFC_CTRL_REG                           DEFINE 0xFF70C0
FAFC_EN                                    DEFINE 0
FAFC_MEAN                                  DEFINE 1
FAST_AFC_EN                                DEFINE 2
FAST_VAL                                   DEFINE 3

RF_FAFC_RESULT_REG                         DEFINE 0xFF70C2

RF_TEST_MODE2_REG                          DEFINE 0xFF70C4
PA_CUR_SET3                                DEFINE 0
PA_ICTRL_ENABLE                            DEFINE 6
RF_TEST_MODE0                              DEFINE 7

CHIP_TEST1_REG                             DEFINE 0xFFFBF4

CHIP_TEST2_REG                             DEFINE 0xFFFBF5

CHIP_ID1_REG                               DEFINE 0xFFFBF8

CHIP_ID2_REG                               DEFINE 0xFFFBF9

CHIP_ID3_REG                               DEFINE 0xFFFBFA

CHIP_SWC_REG                               DEFINE 0xFFFBFB

CHIP_REVISION_REG                          DEFINE 0xFFFBFC

CHIP_CONFIG1_REG                           DEFINE 0xFFFBFD

CHIP_CONFIG2_REG                           DEFINE 0xFFFBFE

CHIP_CONFIG3_REG                           DEFINE 0xFFFBFF

INT_ACK_CR16_START                         DEFINE 0xFFFC00

INT_ACK_CR16_END                           DEFINE 0xFFFFFF

DIP_RAM_START                              DEFINE 0x1000000

DIP_RAM_END                                DEFINE 0x10001FF

DIP_RAM_2_START                            DEFINE 0x1000200

DIP_RAM_2_END                              DEFINE 0x10003FF

DIP_RAM_3_START                            DEFINE 0x1000400

DIP_RAM_3_END                              DEFINE 0x10004FF

DSP_MAIN_SYNC0_REG                         DEFINE 0x1027F80
RAMIN0_SYNC                                DEFINE 0
RAMIN1_SYNC                                DEFINE 2
RAMIN2_SYNC                                DEFINE 4
RAMIN3_SYNC                                DEFINE 6
RAMOUT0_SYNC                               DEFINE 8
RAMOUT1_SYNC                               DEFINE 10
RAMOUT2_SYNC                               DEFINE 12
RAMOUT3_SYNC                               DEFINE 14

DSP_MAIN_SYNC1_REG                         DEFINE 0x1027F82
DSP_SYNC0                                  DEFINE 0
DSP_SYNC1                                  DEFINE 2
DSP_SYNC2                                  DEFINE 4
AD_SYNC                                    DEFINE 6
DA_CLASSD_SYNC                             DEFINE 8
DA_LSR_SYNC                                DEFINE 10
ADC_SYNC                                   DEFINE 12
PCM_SYNC                                   DEFINE 14

DSP_MAIN_CNT_REG                           DEFINE 0x1027F84

DSP_ADC1S_REG                              DEFINE 0x1027F86

DSP_ADC0S_REG                              DEFINE 0x1027F88

DSP_CLASSD_REG                             DEFINE 0x1027F8A

DSP_CODEC_MIC_GAIN_REG                     DEFINE 0x1027F8C
DSP_MIC_GAIN                               DEFINE 12

DSP_CODEC_OUT_REG                          DEFINE 0x1027F8E

DSP_CODEC_IN_REG                           DEFINE 0x1027F90

DSP_RAM_OUT0_REG                           DEFINE 0x1027F92

DSP_RAM_OUT1_REG                           DEFINE 0x1027F94

DSP_RAM_OUT2_REG                           DEFINE 0x1027F96

DSP_RAM_OUT3_REG                           DEFINE 0x1027F98

DSP_RAM_IN0_REG                            DEFINE 0x1027F9A

DSP_RAM_IN1_REG                            DEFINE 0x1027F9C

DSP_RAM_IN2_REG                            DEFINE 0x1027F9E

DSP_RAM_IN3_REG                            DEFINE 0x1027FA0

DSP_ZCROSS1_OUT_REG                        DEFINE 0x1027FA2
DSP_ZCROSSx                                DEFINE 15

DSP_ZCROSS2_OUT_REG                        DEFINE 0x1027FA4
DSP_ZCROSSx                                DEFINE 15

DSP_PCM_OUT0_REG                           DEFINE 0x1027FA6

DSP_PCM_OUT1_REG                           DEFINE 0x1027FA8

DSP_PCM_OUT2_REG                           DEFINE 0x1027FAA

DSP_PCM_OUT3_REG                           DEFINE 0x1027FAC

DSP_PCM_IN0_REG                            DEFINE 0x1027FAE

DSP_PCM_IN1_REG                            DEFINE 0x1027FB0

DSP_PCM_IN2_REG                            DEFINE 0x1027FB2

DSP_PCM_IN3_REG                            DEFINE 0x1027FB4

DSP_PCM_CTRL_REG                           DEFINE 0x1027FB6
PCM_EN                                     DEFINE 0
PCM_MASTER                                 DEFINE 1
DSP_PCM_SYNC                               DEFINE 2
PCM_FSC0LEN                                DEFINE 3
PCM_FSC0DEL                                DEFINE 5
PCM_PPOD                                   DEFINE 6
PCM_CLKINV                                 DEFINE 7
PCM_FSCINV                                 DEFINE 8
PCM_CLK_BIT                                DEFINE 9
PCM_CH0_DEL                                DEFINE 10
PCM_FSC0LEN48                              DEFINE 15

DSP_PHASE_INFO_REG                         DEFINE 0x1027FB8

DSP_MAIN_CTRL_REG                          DEFINE 0x1027FBC
DSP_MAIN_PRESET                            DEFINE 0
DSP_MAIN_CTRL                              DEFINE 8
PCM_DOMAIN                                 DEFINE 10
AD_DOMAIN                                  DEFINE 11
LSR_DOMAIN                                 DEFINE 12
CLASSD_DOMAIN                              DEFINE 13

DSP_CLASSD_BUZZOFF_REG                     DEFINE 0x1027FBE
BUZZOFF                                    DEFINE 15

DSP_PCM_OUT4_REG                           DEFINE 0x1027FC0

DSP_PCM_OUT5_REG                           DEFINE 0x1027FC2

DSP_PCM_IN4_REG                            DEFINE 0x1027FC4

DSP_PCM_IN5_REG                            DEFINE 0x1027FC6

DSP_CODEC2_IN_REG                          DEFINE 0x1027FC8

DSP_CTRL_REG                               DEFINE 0x1027FD0
DIP_DSP_VEC                                DEFINE 0
DSP_EN                                     DEFINE 2
DSP_CLK_EN                                 DEFINE 3
DSP_CR16_INT                               DEFINE 4
DSP_PATCH                                  DEFINE 5
DBG_EN                                     DEFINE 8

DSP_PC_REG                                 DEFINE 0x1027FD2

DSP_PC_START_REG                           DEFINE 0x1027FD4

DSP_IRQ_START_REG                          DEFINE 0x1027FD6
DSP_IRQ_START                              DEFINE 4

DSP_INT_REG                                DEFINE 0x1027FD8

DSP_INT_MASK_REG                           DEFINE 0x1027FDA

DSP_INT_PRIO1_REG                          DEFINE 0x1027FDC
DSP_INT2_PRIO                              DEFINE 0
DSP_INT1_PRIO                              DEFINE 4
DSP_INT0_PRIO                              DEFINE 8

DSP_INT_PRIO2_REG                          DEFINE 0x1027FDE
DSP_INT5_PRIO                              DEFINE 0
DSP_INT4_PRIO                              DEFINE 4
DSP_INT3_PRIO                              DEFINE 8

DSP_OVERFLOW_REG                           DEFINE 0x1027FE0
INT_OVERFLOW                               DEFINE 0
WTF_OVERFLOW                               DEFINE 6
IRQ_OVERFLOW                               DEFINE 7
M_INT_OVERFLOW                             DEFINE 8
M_WTF_OVERFLOW                             DEFINE 14
M_IRQ_OVERFLOW                             DEFINE 15

DSP_JTBL_REG                               DEFINE 0x1027FE2
DSP_JTBL                                   DEFINE 9

DSP_AUX_REG                                DEFINE 0x1027FE4
CR16_SHRA                                  DEFINE 0

DBG_IREG                                   DEFINE 0x1027FF0

DBG_INOUT_REG_LSW                          DEFINE 0x1027FF4

DBG_INOUT_REG_MSW                          DEFINE 0x1027FF6

DSP_TIMERL_REG                             DEFINE 0x1027FF8

DSP_TIMERH_REG                             DEFINE 0x1027FFA

DSP_TIMER_CTRL_REG                         DEFINE 0x1027FFC
DSP_TIM_CTRL                               DEFINE 0
DSP_TIM_STOP                               DEFINE 1
DSP_TIM_MODE                               DEFINE 2
DSP_TIM_MEM                                DEFINE 4
DSP_TIM_BRIDGE                             DEFINE 5
DSP_TIM_JMP                                DEFINE 6
DSP_TIM_PATCH                              DEFINE 7

DSP_MC_RAM_START                           DEFINE 0x1030000

DSP_MC_RAM_END                             DEFINE 0x10307FF

DSP_MC_SHARED_RAM_START                    DEFINE 0x010000

DSP_MC_SHARED_RAM_END                      DEFINE 0x017FFF

DSP_MC_ROM_START                           DEFINE 0x1040000

DSP_MC_ROM_END                             DEFINE 0x104BFFF

#endif /* __IAR_SYSTEMS_ASM__*/


#define NMI_INT             0x01  /* Non maskable interrupt from DIP <VNMI> and Watchdog timer */ 
#define SVC_TRAP            0x05  /* Supervisor Call Trap */ 
#define DVZ_TRAP            0x06  /* Divide by zero Trap */ 
#define FLG_TRAP            0x07  /* Flag Trap */ 
#define BPT_TRAP            0x08  /* Breakpoint Trap */ 
#define TRC_TRAP            0x09  /* Trace Trap */ 
#define UND_TRAP            0x0A  /* Undefined Instruction Trap */ 
#define IAD_TRAP            0x0C  /* Illegal address Trap */ 
#define DBG_TRAP            0x0E  /* Debug Trap */ 
#define ISE_INT             0x0F  /* In System Emulator Interrupt caused by ISE pin or SDI */ 
#define ACCESS12_INT        0x10  /* Access bus 1 and 2 interrupt */ 
#define KEYB_INT            0x11  /* Keyboard Interrupt or vectored level/edge interrupt */ 
#define UART2_RI_TI_INT     0x12  /* UART 2 interrupt */ 
#define CT_CLASSD_INT      0x13  /* Capture timer 1,2 or Class-D Clipping interrupt */
#define UART_RI_INT         0x14  /* UART RI interrupt */ 
#define UART_TI_INT         0x15  /* UART TI interrupt */ 
#define SPI_INT             0x16  /* SPI interrupt */
#define TIM0_INT            0x17  /* Timer 0 interrupt */ 
#define TIM1_INT            0x18  /* Timer 1 interrupt */ 
#define CLK100_INT          0x19  /* CLK100 interrupt */ 
#define DIP_INT             0x1A  /* DIP Interrupt */ 
#define AD_INT              0x1B  /* ADC interrupt */ 
#define SPI2_INT            0x1C  /* SPI2 interrupt */ 
#define DSP_INT             0x1D  /* Gen2DSP Interrupt */ 
#define ULP_INT             0x1E  /* ULP_INT interrupt */ 


#ifdef __IAR_SYSTEMS_ICC__

/*
 * Extern declarations of all peripheral registers above 16 Mbyte
 * Note that such a pointer has to be declared somewhere,
 * before it can be used.in the application.
 */

extern const __data24 uint16* dsp_main_sync0_reg;
extern const __data24 uint16* dsp_main_sync1_reg; 
extern const __data24 uint16* dsp_main_cnt_reg;
extern const __data24 uint16* dsp_adcos;
extern const __data24 uint16* dsp_adcis;
extern const __data24 uint16* dsp_classd_reg;
extern const __data24 uint16* dsp_codec_mic_gain_reg;
extern const __data24 uint16* dsp_codec_out_reg;
extern const __data24 uint16* dsp_codec_in_reg;
extern const __data24 uint16* dsp_ram_out0_reg;
extern const __data24 uint16* dsp_ram_out1_reg;
extern const __data24 uint16* dsp_ram_out2_reg;
extern const __data24 uint16* dsp_ram_out3_reg;
extern const __data24 uint16* dsp_ram_in0_reg;
extern const __data24 uint16* dsp_ram_in1_reg;
extern const __data24 uint16* dsp_ram_in2_reg;
extern const __data24 uint16* dsp_ram_in3_reg;
extern const __data24 uint16* dsp_zcross1_out_reg;
extern const __data24 uint16* dsp_zcross2_out_reg;
extern const __data24 uint16* dsp_pcm_out0_reg;     
extern const __data24 uint16* dsp_pcm_out1_reg;    
extern const __data24 uint16* dsp_pcm_out2_reg;    
extern const __data24 uint16* dsp_pcm_out3_reg;    
extern const __data24 uint16* dsp_pcm_out4_reg;    
extern const __data24 uint16* dsp_pcm_out5_reg;    
extern const __data24 uint16* dsp_pcm_in0_reg;     
extern const __data24 uint16* dsp_pcm_in1_reg;    
extern const __data24 uint16* dsp_pcm_in2_reg;    
extern const __data24 uint16* dsp_pcm_in3_reg;    
extern const __data24 uint16* dsp_pcm_in4_reg;    
extern const __data24 uint16* dsp_pcm_in5_reg;    
extern const __data24 uint16* dsp_pcm_ctrl_reg;    
extern const __data24 uint16* dsp_phase_info_reg;    
extern const __data24 uint16* dsp_vqi_reg;    
extern const __data24 uint16* dsp_main_ctrl_reg;
extern const __data24 uint16* dsp_classd_buzzoff_reg;       
extern const __data24 uint16* dsp_ctrl_reg;       
extern const __data24 uint16* dsp_pc_reg;    
extern const __data24 uint16* dsp_pc_start_reg;    
extern const __data24 uint16* dsp_irq_start_reg;  
extern const __data24 uint16* dsp_int_reg;        
extern const __data24 uint16* dsp_int_mask_reg;   
extern const __data24 uint16* dsp_int_prio1_reg;   
extern const __data24 uint16* dsp_int_prio2_reg;   
extern const __data24 uint16* dsp_overflow_reg;   
extern const __data24 uint16* dbg_ireg;   
extern const __data24 uint16* dbg_inout_reg_lsw;   
extern const __data24 uint16* dbg_inout_reg_msw;   

#endif //#ifdef __IAR_SYSTEMS_ICC__

/*
 * Missing bit field definitions for GPIO registers
 * This is not done in the datasheet to avoid very long tables
 * that contain no extra information.
 */

#define __GPIO_DATA_REG        __GPIO_BITFIELD_REG
#define __GPIO_DIR_REG         __GPIO_BITFIELD_REG
#define __GPIO_PUPD_REG        __GPIO_BITFIELD_REG
#define __GPIO_INT_EN_REG      __GPIO_BITFIELD_REG

/*====================================================*/
struct __GPIO_BITFIELD_REG
/*====================================================*/
{
    WORD BITFLD_GPIO_0                        : 1;
    WORD BITFLD_GPIO_1                        : 1;
    WORD BITFLD_GPIO_2                        : 1;
    WORD BITFLD_GPIO_3                        : 1;
    WORD BITFLD_GPIO_4                        : 1;
    WORD BITFLD_GPIO_5                        : 1;
    WORD BITFLD_GPIO_6                        : 1;
    WORD BITFLD_GPIO_7                        : 1;
    WORD BITFLD_GPIO_8                        : 1;
    WORD BITFLD_GPIO_9                        : 1;
    WORD BITFLD_GPIO_10                       : 1;
    WORD BITFLD_GPIO_11                       : 1;
    WORD BITFLD_GPIO_12                       : 1;
    WORD BITFLD_GPIO_13                       : 1;
    WORD BITFLD_GPIO_14                       : 1;
    WORD BITFLD_GPIO_15                       : 1;
};

#define GPIO_0                        (0x0001)
#define GPIO_1                        (0x0002)
#define GPIO_2                        (0x0004)
#define GPIO_3                        (0x0008)
#define GPIO_4                        (0x0010)
#define GPIO_5                        (0x0020)
#define GPIO_6                        (0x0040)
#define GPIO_7                        (0x0080)
#define GPIO_8                        (0x0100)
#define GPIO_9                        (0x0200)
#define GPIO_10                       (0x0400)
#define GPIO_11                       (0x0800)
#define GPIO_12                       (0x1000)
#define GPIO_13                       (0x2000)
#define GPIO_14                       (0x4000)
#define GPIO_15                       (0x8000)

#define SHIF(a) ((a)&0x0001?0: (a)&0x0002?1: (a)&0x0004?2: (a)&0x0008?3:\
                 (a)&0x0010?4: (a)&0x0020?5: (a)&0x0040?6: (a)&0x0080?7:\
                 (a)&0x0100?8: (a)&0x0200?9: (a)&0x0400?10:(a)&0x0800?11:\
                 (a)&0x1000?12:(a)&0x2000?13:(a)&0x4000?14: 15)

#define DSHIF(a)((a)&0x00000001?0: (a)&0x00000002?1: (a)&0x00000004?2: (a)&0x00000008?3:\
                 (a)&0x00000010?4: (a)&0x00000020?5: (a)&0x00000040?6: (a)&0x00000080?7:\
                 (a)&0x00000100?8: (a)&0x00000200?9: (a)&0x00000400?10:(a)&0x00000800?11:\
                 (a)&0x00001000?12:(a)&0x00002000?13:(a)&0x00004000?14:(a)&0x00008000?15:\
                 (a)&0x00010000?16:(a)&0x00020000?17:(a)&0x00040000?18:(a)&0x00080000?19:\
                 (a)&0x00100000?20:(a)&0x00200000?21:(a)&0x00400000?22:(a)&0x00800000?23:\
                 (a)&0x01000000?24:(a)&0x02000000?25:(a)&0x04000000?26:(a)&0x08000000?27:\
                 (a)&0x10000000?28:(a)&0x20000000?29:(a)&0x40000000?30: 31)

#ifdef IO_BY_FUNCTION_CALLS
    WORD fc_get_word(BYTE* a);
    WORD fc_get_bits(BYTE* a, WORD msk);
    void fc_set_word(BYTE* a, WORD v);
    void fc_set_bits(BYTE* a, WORD msh, WORD v);

    void fc_set_PSR_I_bit(void);
    void fc_reset_PSR_I_bit(void);
    void fc_enable_interrupt(void);
    void fc_disable_interrupt(void);
    void fc_wait(void);

    #define GetByte(a)  	fc_get_byte((BYTE*)a)
    #define GetWord(a)  	fc_get_word((BYTE*)a)
    #define GetBits(a,f)	fc_get_bits((BYTE*)a,f) 
    #define SetByte(a,d)	fc_set_byte((BYTE*)a,d)    
    #define SetWord(a,d)	fc_set_word((BYTE*)a,d)
    #define SetBits(a,f,d)	fc_set_bits((BYTE*)a,f,d)
#else //#ifdef IO_BY_FUNCTION_CALLS
    #define GetByte(a)  	(* ( __far volatile BYTE*)(a) )
    #define GetWord(a)  	(* ( __far volatile WORD*)(a) )
    #define GetDword(a)  	(* ( __far volatile DWORD*)(a) )
    #define GetBits(a,f)	(( ( __far volatile struct __##a *)(a))->BITFLD_##f )
    #define GetDbits(a,f)	(( ( __far volatile struct __##a *)(a))->BITFLD_##f ) 
    #define SetByte(a,d)	(* ( __far volatile BYTE*)(a)=(d) )
    #define SetWord(a,d)	(* ( __far volatile WORD*)(a)=(d) )
    #define SetDword(a,d)	(* ( __far volatile DWORD*)(a)=(d) )
    #define SetBits(a,f,d)	( SetWord( a, (GetWord(a)&((WORD)~f)) | ((d)<<SHIF(f)) ))
    #define SetDbits(a,f,d)	( SetDword(a, (GetDword(a)&(~(DWORD)f)) | (((DWORD)d)<<DSHIF(f)) )
#endif //#ifdef IO_BY_FUNCTION_CALLS

#endif //#ifndef _IO14441_INCLUDED

