/*********************************************************************
*                     SEGGER Microcontroller GmbH                    *
*                        The Embedded Experts                        *
**********************************************************************
*                                                                    *
*       (c) 1995 - 2020 SEGGER Microcontroller GmbH                  *
*                                                                    *
*       Internet: segger.com  Support: support_embos@segger.com      *
*                                                                    *
**********************************************************************
*                                                                    *
*       embOS * Real time operating system for microcontrollers      *
*                                                                    *
*       Please note:                                                 *
*                                                                    *
*       Knowledge of this file may under no circumstances            *
*       be used to write a similar product or a real-time            *
*       operating system for in-house use.                           *
*                                                                    *
*       Thank you for your fairness !                                *
*                                                                    *
**********************************************************************
*                                                                    *
*       OS version: V5.10.2.0                                        *
*                                                                    *
**********************************************************************

-------------------------- END-OF-HEADER -----------------------------
File    : BSP.c
Purpose : BSP for CR16C simulator
*/

#include "BSP.h"

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/

//
// General Purpose Input Output C (GPIOC)
//
#define GPIOC_BASE_ADDR  (0x48000800uL)
#define GPIOC_CTRL       (*(volatile unsigned long*)(GPIOC_BASE_ADDR + 0x00uL))  // Control
#define GPIOC_DOR        (*(volatile unsigned long*)(GPIOC_BASE_ADDR + 0x14uL))  // Data output
#define GPIOC_BOR        (*(volatile unsigned long*)(GPIOC_BASE_ADDR + 0x18uL))  // Bit operation
#define GPIOC_BCR        (*(volatile unsigned long*)(GPIOC_BASE_ADDR + 0x28uL))  // Bit clear

/*********************************************************************
*
*       Global functions
*
**********************************************************************
*/

/*********************************************************************
*
*       BSP_Init()
*/
void BSP_Init(void) {
}

/*********************************************************************
*
*       BSP_SetLED()
*/
void BSP_SetLED(int Index) {
  BSP_USE_PARA(Index);
}

/*********************************************************************
*
*       BSP_ClrLED()
*/
void BSP_ClrLED(int Index) {
  BSP_USE_PARA(Index);
}

/*********************************************************************
*
*       BSP_ToggleLED()
*/
void BSP_ToggleLED(int Index) {
  BSP_USE_PARA(Index);
}

/*************************** End of file ****************************/
